#!/usr/bin/X11/tixwish
#  File: images.tcl
# 
#      This file is part of minkowsky
# 
#      Copyright (C) 2001-2002 by Rdiger Goetz
#      Author: Rdiger Goetz <minkowsky@r-goetz.de>
# 
#      Time-stamp: <03-Jun-2002 14:26:30 goetz>
# 
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
# 
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
# 
#      You should have received a copy of the GNU General Public License
#      along with this program; if not, write to the Free Software
#      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#  
proc initIcons { } {
    global multiUserGroupCalIcon onlyCommonIcon
    global dayCalIcon weekCalIcon monthCalIcon
    global quitIcon ignoreIcon helpIcon userPrefsIcon
    global newIcon
    global ignoreIcon_in ignoreIcon_out
    global onlyCommonIcon_in onlyCommonIcon_out
    global multiUserGroupCalIcon_in multiUserGroupCalIcon_out
    global newProjIcon
    global up12Icon down12Icon up12Img down12Img
    global up10Icon down10Icon up10Img down10Img
    global done12Icon open12Icon done12Img open12Img
    global OptMenuPullImg
    global reloadIcon jumpIcon goHomeIcon
    global printerIcon
    global ignoreInfoIcon_in ignoreInfoIcon_out
    global vd_deleteDateIcon vd_suspendDateIcon vd_shiftDateIcon 
    global vd_modifyDateIcon vd_reminderOnIcon vd_reminderOffIcon
    global minkoIcon24 minkoIcon128
    global groupListExclusiveIcon groupListAllIcon groupListEmptyIcon
    global adrFolderIcon adrFilterIcon
    global selDateCalIcon jumpHomeIcon
    global intoClipBoardIcon

    set minkoIcon128 {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"128 128 257 2",
"   c Gray0",
".  c #080707",
"X  c #0a0807",
"o  c #0b0b0b",
"O  c #100f0d",
"+  c #11100e",
"@  c #18100b",
"#  c #141413",
"$  c #181614",
"%  c #1a1916",
"&  c #1c1b1b",
"*  c #211f1c",
"=  c #2e1f16",
"-  c #261a12",
";  c #23211d",
":  c #362519",
">  c #242322",
",  c #282622",
"<  c #2d2a25",
"1  c #2c2c2c",
"2  c #312e29",
"3  c #36322d",
"4  c #39352f",
"5  c #393630",
"6  c #3d3933",
"7  c Gray24",
"8  c #343434",
"9  c #42362b",
"0  c #413d36",
"q  c #433f38",
"w  c #45413a",
"e  c #4b463f",
"r  c #53483d",
"t  c Gray27",
"y  c #4f4a42",
"u  c #4b4b4b",
"i  c #5c4e41",
"p  c #534e45",
"a  c #555047",
"s  c #5e584f",
"d  c #5a544b",
"f  c #535353",
"g  c #5b5b5b",
"h  c #615b51",
"j  c #696257",
"k  c #6b6459",
"l  c #726b5f",
"z  c #646464",
"x  c #6d6d6d",
"c  c #746d61",
"v  c #7b7367",
"b  c #7f776a",
"n  c Gray45",
"m  c #7b7b7b",
"M  c #926445",
"N  c #997458",
"B  c #867869",
"V  c #9b7e65",
"C  c #b17b56",
"Z  c #aa7f60",
"A  c #8c8375",
"S  c #938a7b",
"D  c #988f7f",
"F  c #be8d5e",
"G  c #bd915f",
"H  c #a68e77",
"J  c #bb9660",
"K  c #b99b62",
"L  c #afb76a",
"P  c #adbc6b",
"I  c #b3ac67",
"U  c #b6a464",
"Y  c #b1b268",
"T  c #a8ca6f",
"R  c #a0df75",
"E  c #a5d472",
"W  c #a0e276",
"Q  c #a5e27b",
"!  c #a9e37f",
"~  c #c2855c",
"^  c #c3885f",
"/  c #c48663",
"(  c #c58b63",
")  c #c7886f",
"_  c #c88d67",
"`  c #c88f68",
"'  c #cb8a7a",
"]  c #c98976",
"[  c #ca936c",
"a_ c #c29264",
"c_ c #cc9670",
"|  c #ce9b75",
" . c #d4967a",
".. c #d09d77",
"X. c #d09e79",
"o. c #c9b27e",
"O. c #d2a27d",
"+. c #848484",
"@. c Gray55",
"#. c #9c9282",
"$. c #939393",
"%. c Gray61",
"&. c #a59a89",
"*. c #a59b8a",
"=. c #aba18f",
"-. c #aea391",
";. c #b7a98c",
":. c #baa282",
">. c #b7ab99",
",. c #baae9b",
"<. c #b2a795",
"1. c #bdb19e",
"2. c #b5b198",
"3. c Gray64",
"4. c Gray67",
"5. c #b2bda7",
"6. c #b4b4b4",
"7. c #b9b9b9",
"8. c #aecbb9",
"9. c #ade483",
"0. c #b1e487",
"q. c #b6e58c",
"w. c #b8e58e",
"e. c #bde693",
"r. c #a9dbcf",
"t. c #bbddff",
"y. c #a2f6f3",
"u. c #a0ffff",
"i. c #aaf9fc",
"p. c #b6e4ff",
"a. c #b5fbf5",
"s. c #b9faf4",
"d. c #bdf2f4",
"f. c #cd8b84",
"g. c #cf8d8c",
"h. c #d08d8e",
"j. c #d18e94",
"k. c #d48f9c",
"l. c #d691a5",
"z. c #d791a8",
"x. c #d892ab",
"c. c #dc94b8",
"v. c #ccae8e",
"b. c #c4bf82",
"n. c #d5a681",
"m. c #d6a985",
"M. c #d8ab87",
"N. c #d9ad8a",
"B. c #dbb18e",
"V. c #ddb592",
"C. c #dfb896",
"Z. c #d0b59a",
"A. c #c2b5a2",
"S. c #c6b9a5",
"D. c #c8bca7",
"F. c #cabda8",
"G. c #e3a592",
"H. c #ebac9f",
"J. c #e0b997",
"K. c #e2bc9b",
"L. c #e5bda0",
"P. c #f3b4ad",
"I. c #de95c2",
"U. c #d6beff",
"Y. c #dabbfe",
"T. c #ddb6ff",
"R. c #e097c9",
"E. c #e699db",
"W. c #e398d3",
"Q. c #e99ce7",
"!. c #ea9cea",
"~. c #ee9ffb",
"^. c #ec9df1",
"/. c #eea9ec",
"(. c #e9a7ff",
"). c #f0a0ff",
"_. c #f2aff6",
"`. c #f2abf9",
"'. c #f5beef",
"]. c #f3b2f5",
"[. c #f4b8f1",
"b_ c #cec1ac",
"d_ c #d1c4ae",
"|. c #dfc5a9",
" X c #d4c7b1",
".X c #daccb6",
"XX c #dccfb8",
"oX c #ded1ba",
"OX c #c8e79e",
"+X c #c4e79a",
"@X c #cde8a3",
"#X c #d1e8a7",
"$X c #d9e9af",
"%X c #ddeab3",
"&X c #e4c09f",
"*X c #e5c3a3",
"=X c #e8c7a7",
"-X c #e8c7a8",
";X c #eacbac",
":X c #e2c9ad",
">X c #eccfb1",
",X c #e2d4bd",
"<X c #eed2b4",
"1X c #f3c9b6",
"2X c #f0d5b7",
"3X c #f1d6b9",
"4X c #f3dabd",
"5X c #e6ebbc",
"6X c #e9ecbf",
"7X c Gray76",
"8X c Gray80",
"9X c #d3d3d3",
"0X c gainsboro",
"qX c #c6d1ff",
"wX c #d2c3ff",
"eX c #ceeada",
"rX c #ccf7ea",
"tX c #c1f9f0",
"yX c #d6f5e6",
"uX c #ddf5e3",
"iX c #e6d8c0",
"pX c #ebdcc5",
"aX c #ffc0c0",
"sX c #ffcbc5",
"dX c #f3c7d6",
"fX c #f5dec1",
"gX c #ffd6ca",
"hX c #ffdccc",
"jX c #fdd2c6",
"kX c #fcddde",
"lX c #f7c4eb",
"zX c #f8cde6",
"xX c #f8cbe8",
"cX c #f9d3e3",
"vX c #fad9e1",
"bX c #efe0c7",
"nX c #eee1c8",
"mX c #ececc2",
"MX c #eaf2dd",
"NX c #f7e1c5",
"BX c #f3e4cb",
"VX c #f5eccb",
"CX c #f8e3c7",
"ZX c #f9e5ca",
"AX c #fbe9ce",
"SX c #f1edc7",
"DX c #ffe4d0",
"FX c #fde3db",
"GX c PapayaWhip",
"HX c #fde8d8",
"JX c #f3f0da",
"KX c #f8f0d7",
"LX c #e4e4e4",
"PX c Gray92",
"IX c #f4f4f4",
"UX c Gray100",
"YX c None",
/* pixels */
"                                                                                                                                                                                                                                                                ",
"GX                                                                UX                                                                                                                                                                                          GX",
"GXGXGX                                                            UX                                                                                                                                                              UX                      GXGXGX",
"GXGXGXGXGX                              UX                        UXUX                                            8 7X                                                                              UX                          UXUXUX                GX~ GXGXGX",
"GXGXGXGXGXGXGX                        UXUXUX                    UXUXUXUX                                          z $.                                                    . UX                      UX                            UX              GXGXGX~ GXGXGX",
"~ GXGXGXGXGXGXGXGX                      UX                    UXUXUXUXUXUXUXUX                                  @.IXIXt                                                 $ IXUXIX                  UXUXUX                                      GXGXGXGXGX~ GXGXGX",
"GX~ ~ GXGXGXGXGXGXGXGX                                    UXUXUXUXUXUXUXUX                    f +.          4.0XIXUXUXPXPX                      & .     & o               > 9X                UXUXUXUXUXUXUX                              GXGXGXGXGXGXGX~ GXGXGX",
"GXGXGX~ GXGXGXGXGXGXGX~ GX                                      UXUXUXUX                    x PX0X8         1 u UXUX7.& o                   o z 9X,   . IX&                                       UXUXUX                              GXGXGXGXGXGXGXGXGX~ GX~ ~ ",
"GXGXGXGX~ GXGXGXGXGXGX~ GXGXGX                                    UXUX                      8 LXu             & 4.m o                       @.PX0Xg   g 8X7                                         UX                            GXGXGXGXGXGXGXGXGXGXGX~ ~ GXGX",
"GXGXGXGXGX~ ~ GXGXGXGX~ GXGXGXGXGX                                UXIX                      . t                 UX                          # 4.    u 9XUX4.8                                       UX                        GXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGX~ GXGXGX~ GXGXGXGXGXGXGX                            > 0X                                        > <                               1 3.UXUXUXUX$.+.+.7                                                       GXGXGXGXGXGXGXGXGXGXGXGXGX~ ~ ~ GXGXGX",
"GXGXGXGXGXGXGXGX~ GXGX~ GXGXGXGXGXGXGXGXGX                          &                                                                     o x m IXUXUXUXUXUX9Xf g o                                                   GXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGX~ ~ ~ GXGXGXGXGXGXGXGXGXGXGX                                                                                            f n z 3.UXUXUXUXf o                                                     GX~ GXGXGXGXGXGXGXGXGXGXGXGX~ ~ GXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGXGX                                                                                            . 8 LXUXx .                                                     GXGXGX~ GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ ~ GXGXGXGXGXGXGXGXGXGXGXGXGXpX                                                                                          +.UX6.                            $.x               + , 6 GXGXGXGXGX~ GXGXGXGXGXGXGXGXGX~ ~ GXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GX~ ~ GXGXGXGXGXGXGXGXGXGXGXGXXX#.                              $ @.                                                    $ 8X&                         f 0XUXUXg         s j *.GXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGXZ.B <                           $.1                                                                                     g x . * o b .XD.GXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXV.;Xc q                       z IXf                                                                                   > &.A 1.GXGXGXGXGXGXGXGXGXGXGXGXGXGXZX~ GXGXGXGXGX~ ~ GXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGX~ ~ GXGXGXGXGXGXGXGXGXX.ZXGX,.                  7 u UXUXz t                                                                     . 3 3 B GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXfX( GXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGX( GXGXNXS.                PXIXUXUXPXt                       3.                                      2 A A .XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX2X` GXAX~ ~ GXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXAX[ GXKXGXGXGXGXGX[ GXGXGXBXj $           # 1 UXUXx &                       $.u                                 h H Z ZXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX;Xc_2X[ GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGX<X| K.GXGXGXGX4XN.GXGXGXGXGXo             & 7Xn                         g 0Xn   #                       v 1.pX4X~ <XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXKXGXGX-Xn.` N.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXAX;XC.fXGXGXGX*X-XGXGXGXGXGXS.2             LX                        4.UXUX7X9X                  d D iXGXGXGX| K.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX3X2X4X[ -X| V.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGX-X-XGXGXGXm.ZXGXGXGXGXGXGXh >         t f                     +.9XUXUX3.<                 0 b_GXGXGXGXGXV.m.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXfX&X<X*X[ *XJ.K.KXKX| *XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGX[ GXGXGX` GXGXGXGXGXGXGXGX$         <                     t m 0XUX@.                A GXGXGXGXGXGXGX-X` BXGXGXGXGXGXGXGXGXGXGXGXGXGXGX4XN.B.&XO.K.3X*X2XGXGXGXGXGXCX( <XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGX3Xn.4XGX[ GXGXGXGXGXGXGXGX=.,                               > %.f             $ *.GXGXGXGXGXGXGXGXfX( ;XGXGXGXGXGXGXGXGXGXGXKXGX&XB.C.;XGXAXCXGXGXKXKXGXGXGXGXGXGX>X( CXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXDX~ GXGXGXGXGXGXGXGXGXGXGXBXV.;XCXN.GXGXGXGXGXGXGXGXGXe $                               9X            2 ZXGXGXGXGXGXGXGXGXGXn.V.GXGXGXGXGXGXGXGX*XC.V.N.K.DXHXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXJ.X.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXDX~ R GXGXGXGXGXGXGXGXGXGXGXGX( -X;XGXGXGXGXGXGXGXGXGXAX                              f o         y GXGXGXGXGXGXGXGXGXGXGX*Xc_AXGXGXGXGXL.~ ~ C.GXGXKXHXlX_.).zXGXGXGXGXGXGXGXGXGXGXGXGXGXGXm.B.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXF W Q q.KXGXGXGXGXGXGXGXGXGX*X| ZXGXGXGXGXGXGXGXGXGXGX#.                                      j GXGXGXGXGXGXGXGXGXGXGXCX( ;XGXGXZXC.C.ZXGXFXlX_.).).).).).[.HXGXGXGXGXGXGXGXGXGXGXGXGXGXCX[ *XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXF W W Q #XGXGXGXGXGXGXGXGXGX>X~ GXGXGXGXGXGXGXGXGXGXGXGX9 .                               6 GXGXGXGXGXGXGXGXGXGXGXGXGXN.m.GX4XC.>XGXGXkX).~.~.).).).).).~.zXGXGXGXGXGXGXGXGXGXGXGXGXGXGX;X^ <XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"~ GXGXGXGXGXGXGXGXGXGX~ W W R 9.%XVXGXGXGXGXGXGXGXGX~ ;XGXGXGXGXGXGXGXGXGXGX*XCX.                             y GXGXGXGXGXGXGXGXGXGXGXGXGX<X~ [ C.3XGXFXlX(.~.).~.~.~.).).).)._.kXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.| ZXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GX~ GXGXGXGXGXGXGXGXGX~ W W R R R 5XGXGXGXGXGXGXGXGXc_*XGXGXGXGXGXGXGXGXGXGX[ oX>.                          pXGXGXGXGXGXGXGXGXGXGXGXGXGXGXn.N.GXHX[.~.~.~.~.~.).~.~.~.).).).).lXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXn.N.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGX~ GXGXGXGXGXGXGXAXF R W W W W 0.GXGXGXGXGXGXGX4X&X` GXGXGXGXGXGXGXGXGXGXO.GXb_B                       1.GXGXGXGXGXGXGXGXGXGXGXGX4Xn.( ~ <X'.).).).).).).).).).).).).~.~.~.cXGXGXGXGXGXGXGXGXGXGXGXGXGXMXnX[ J.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGX~ ~ GXGXGXGXGXAXF R W W W W W 5XGXGXGXGXGXGX*X3XK.CXGXGXGXGXGXGXGXGX4X>XGXGXS.s                 6 AXGXGXGXGXGXGXGXGXGXGXGXGX-X>XGXV.h.).).).).).).).).).).).).).).~.~._.kXGXGXGXGXGXuXyXs.s.uXs.a.u.u.r.F ;XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGX~ GXGXGXGXZXG W W W W W W w.GXGXGXGXGXGXN.KX-XCXGXGXGXGXGXGXGXGXV.GXGXGXnXS.p               GXGXGXGXGXGXGXGXGXGXGXGXGXn.fXGXCXc_c.).).).).).).).).).).).).).).~.~.T.d.rXyXa.y.u.u.u.u.u.u.u.u.u.u.8.( 3XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGX~ DXGXGXCXG W W W W W W Q OXGXGXGXGXGX..KXZXN.CXGXGXGXGXGXGXGX( GXGXGXGXoX Xa         e ,XGXGXGXGXGXGXGXGXGXGXGX>X| GXGXGX;X/ W.).).).).).).).).).).).).).).).).U.u.u.u.u.u.u.u.u.u.u.u.u.u.u.u.5.| ZXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXF KXKXNXG W W W W W W W W GXGXGXGXGX~ GXGX| NXGXGXGXGXGXGXGXO.GXGXGXGXGX,XpXl   ;   GXGXGXGXGXGXGXGXGXGXGXGXO.-XGXGXGXGXJ.] Q.~.).).).).).).).).).).).).).).).U.u.u.u.u.u.u.u.u.u.u.u.u.u.u.u.2.n.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXAX[ KX4XK W W W W W W W W #XGXGXGXGX[ GXGXfXV.GXGXGXGXGXGXGX&XGXGXGXGXGXGXpXGX*.4 Z KXGXGXGXGXGXGXGXGXGXGXN.GXGXGXGXGXGXV.f.^.~.).).).).).).).).).).).).).~.~.U.u.u.u.u.u.u.u.u.u.u.u.u.u.u.y.;.N.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGX~ ",
"GXGXGXGXGXGXGXGX4XO.m.U W W W W W W W W q.GXGXGXGXm.GXGXGXm.GXGXGXGXGXGX<XNXGXGXGXGXGXGXGXGXGX:X-XKXGXGXGXGXGXGXGXGXGX*XZXGXGXGXGXGXGXN.f.!.).).).).).).).).).).).).).).~.~.T.i.u.u.u.u.u.u.u.u.u.u.u.u.u.y.:.V.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ ~ ~ GX",
"GXGXGXGXGXGXGXGXAX=Xn.I W W W W W W W W W e.GXGXAXV.GXGXGXJ.GXGXGXGXGXGXV.GXGXGXGXGXGXGXGXGXGXB.DXGXGXGXGXGXGXGXGXGX*X<XGXGXGXGXGXGXGXB.' Q.).).).).).).).).).).).).).).~.~.(.p.u.u.u.u.u.u.u.u.u.u.u.u.u.y.H C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXKXKX;XI W W W W W W W W W W GXGX4X*XGXGXGX=X4XKXGXGXGXGX| GXGXGXGXGXGXGXGXGXGX[ GXGXGXGXGXGXGXGXGXGX;XGXGXGXGXGXGXGXGXK./ I.~.~.).).).).).).).).).).).).).).).qXu.u.u.u.u.u.u.u.u.u.u.u.u.y.:.C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXKXKXGXfXZXF F GXGXGX",
"GXGXGXGXGXGXGXGXGXKX;XY W W W W W W W W W W $XGX<X<XGXGXGXKX..AXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGX` GXGXGXGXGXGXGXGX<X[ GXGXGXGXGXGXGXGXHX>X[ l.~.~.).).).).).).).).).).).).).).~.T.i.u.u.u.u.u.u.u.u.u.u.u.u.y.:.C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCX*Xc__ GXC GXGXGX",
"GXGXGXGXGXGXGXGXGXGX=XL W W W W W W W W W W e.GX=X4XGXGXGXGXN.NXGXGXGXGX[ KXGXGXGXGXGXGXGXGXGXn.GXGXGXGXGXGXGXZXN.GXGXGXGXGXGXGXGXGXGXGXV.) I.).).).).).).).).).).).).).).).~.).t.u.u.u.u.u.u.u.i.u.u.u.i.u.;.B.GXGXGXGXGXGXGXGXGXGXKXGX;X3X;XB.C.GXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGX&XL W W W W W W W W W W W OX&XZXGXGXGXGXKXM.GXGXKXKXO.KXGXGXGXGXGXGXGXGXZXC.GXGXGXGXGXGXGXV.GXGXGXGXGXGXGXGXGXGXGXGX3XX.f.E.).).).).).).).).).).).).).).).).U.u.a.rXyXi.rXyXJXKXJXeXMXKXv.m.ZXGXGXGXAXKX<XK.=XNXK...&Xm.N.3XGXGXGXGX~ GXGXHX",
"GXGXGXGXGXGXGXGXGXGX&XP W W W W W W W W W W W W J.AXKXKXGXGXGXB.AXGXGXGXB.GXGXGXGXGXGXGXGXGX3X-XGXGXGXGXGXGXCX-XGXGXGXGXGXGXGXGXGXGXGXGXGX<X| f.E.~.).).).).).).).).).).).).).).).dXKXZXZXK.K.| <XV.J.N.c_N.V.[ ` N.| &XN.[ C.*X&X..-XNXAXGXGXGXGXGXKXDX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXKXK.b.W W W W W W W W W W W W o.KXGXGXGXGXGX-XAXGXGXGXJ.GXGXGXGXGXGXGXGXGX;X<XGXGXGXGXGXGXV.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXfXn.] R.).).).).).).).).).).).).).).)./.n.~ J.B.<XZX<X*X2XGXZXKXO.c_GXZXGX;XGXAXAXGXKXGXGXKXGXGXGXGXGXGXKXAX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXK.=X0.W W W W W W W W W W W I GXGXGXGXGXGX4X*XCXGXGXK.KXGXGXGXGXGXGXGXGX-X2XGXGXGXGXGXC.K.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXHXJ./ x.).).).).).).).).).).).).).).).zXGXKXGXGXGXGXGXGXGXKXGX2X^ fXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXJ.=X6XW W W W W W W W W W W I GXGXGXGXGXGXGX~ ;XGXGXK.GXGXGXGXGXGXGXGXKX;X<XGXGXGXGXGXN.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX3XO.f.E.).).).).).).).).).).).).).).HXGXGXHXGXGXGXGXGXGXGXZX` >XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXJ.=XKX! W W W W W W W W W W Y GXGXGXGXGXGXGX-XJ.GXGXJ.GXGXGXGXGXGXGXGXGX<X;XGXGXGXGXfXfXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX*X/ c.(.~.).).).).).).).).).).).'.GXGXGXGXGXGXGXGXGXGXGXO.K.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX^ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXJ.=XGXGXW W W W W W W W W W Y AXGXGXGXGXGXGXKXK.GXGXV.GXGXGXGXGXGXGXGXGX3X&XGXGXGXGXB.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAXm.f.~.).).).).).).).).).).).).kXGXGXGXGXGXGXGXGXGXGXC.m.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXKXZX^ GXGXGX",
"GXGXGXGXGXGXGXGXKXKXV.;XGXGXq.W W W W W W W W W Y CXGXGXGXGXGXGXGXCXV.GXm.GXGXGXGXGXGXGXGXGXAXB.GXGXGXGXV.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX-X/ E.~.).).).).).).).).).)._.GXGXGXGXGXGXGXGXGXGX<Xc_GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCX^ GXGXGX",
"GXGXGXGXGXGXGXGXKXKXV.=XGXGXmXW W W W W W W W W T 4XGXGXGXGXGXGXGXGX..CX| GXGXGXGXGXGXGXGXGXGX| GXGXGX;XV.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCXV.( c.).).).).).).).).).).(.zXGXGXGXGXGXGXGXGXGXAX/ fXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCX^ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXJ.=XGXGXGXw.W W W W W W W W T >XGXGXGXGXGXGXGXGXCXO.~ GXGXGXGXGXGXGXGXGXGX/ GXGXGXO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCXN.;Xm.z.(.).).).).).).).).).).GXGXGXGXGXGXGXGXGXGXO.-XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX^ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXJ.*XGXGXGX6XW W W W W W W W E &XGXGXGXGXGXGXGXGXGXm.( GXGXGXGXGXGXGXGXGXGXm.ZXGXGXC.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZXN.;XGXC.k.).).).).).).).).).).lXGXGXGXGXGXGXGXGXGXC.V.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX( GXGXGX",
"GXGXGXGXGXGXGXGXGXGXJ.&XGXGXGXGXe.W W W W W W W W B.GXGXGXGXGXGXGXGXGXDXB.GXGXGXGXGXGXGXGXGXGX>XK.GXGX` GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXDXK.*XDXGXL.k.~.~.).).).).).).).).DXGXGXGXGXGXGXGXGX2X| GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCX^ GXGXGX",
"GXGXGXGXGXGXGXGXKXKX&X&XGXGXGXGX6XW W W W W W W W O.GXGXGXGXGXGXGXGXGXGX<XN.GXGXGXGXGXGXGXGXGXGX` GXGXC.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX-XK.ZXGXGXL.z.~.~.).).).).).).).'.GXGXGXGXGXGXGXGXGX/ AXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXKXCX( GXGXAX",
"GXGXGXGXGXGXGXGXGXGX&XJ.GXGXGXGXKX+XW W W W W W W ( KXAXGXGXGXGXGXGXGXGXGX_ <XNXKXGXGXGXGXGXGXGXm.fXGX( GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXN.C.fXGXGXGXC.I.~.).).).).).).).).GXGXGXGXGXGXGXGXGXn.>XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX^ GXGXGX",
"GXGXGXGXGXGXGXGXGXGX=XV.GXGXGXGXAX6XW W W W W W W a_KXKXGXGXGXGXGXGXGXGXGX_ M.O.GXGXGXGXGXGXGXGXBXO.GXJ.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX*XC.GXGXGXGXGXX.Q.).).).).).).).).lXGXGXGXGXGXGXGXGXL.C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX^ GXGXGX",
"GXGXGXGXGXGXGXGXKXKX;XB.GXGXGXGXKXAX+XW W W W W W U GXGXGXGXGXGXGXGXGXGXGXn.NX*XC.GXGXGXGXGXGXGXKXn.2X| AXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX4Xm.GXGXGXGXGXGXF ).).).).).).).).~.GXGXGXGXGXGXGXGXfX| GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXKX;XM.GXGXGXGXKXKXSXQ W W W W W P 2XGXGXGXGXGXGXGXGXGXGX3X<XGXV.*XGXGXGXGXGXGXKXDX( ` GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.CXGXGXGXGXGXCXj.).).).).).).).~.xXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX~ GXGXGX",
"GXGXKXKXAXKXGXGXGXGX<Xm.KXGXGXGXKXAXGXVX! W W W W E J.KXKXGXKXKXGXGXGXGXGXGX| GXGXm.*X;XGXGXGXGXGXGX*X[ KXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXBX~ C.GXGXGXGXGXGXC.E.).).).).).).~.(.GXGXGXGXGXGXGXGXX.fXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX~ KXGXGX",
"~ GXKXAXGXKXGXGXGXGX2XO.GXGXGXGXKXKXGXGX$XW W W W W ..AXGXGXAXGXGXGXGXGXGXGXm.GXGXGXV.O.C.ZXGXGXGXGXGXB.V.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.GXGXGXGXGXGXGXHX~ ).).).).).).~.~.kXGXGXGXGXGXGXGXJ.*XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX~ KXGXGX",
"GX~ KXKXGXGXGXGXGXGX4X| GXGXGXGXGXGXGXGXKXq.W W W W F KXGXGXGXGXGXGXGXGXGXGXZXC.GXGXGXfXC.m.4X*X4XAXAX3X( N.GXGXGXGXGXGXGXGXGXGXGXHXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAXK.GXGXGXGXGXGXGX<XI.).).).).).~.~.'.GXGXGXGXGXGXGX3Xm.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAX~ GXGXGX",
"GXAX` KXGXGXGXGXGXGXNX[ GXGXGXGXGXGXGXGXAX6XW W W W I NXGXGXGXGXGXGXGXGXGXGXGX` GXGXGXGXKXBXK.| n.V.-X[ n.J.c_2XGXGXGXGXGXGXGXGXCXV.c_F ( ~ ` N.<XGXGXGXGXGXGXGXDX| GXGXGXGXGXGXGXGX( ).).).).).).~.~.GXGXGXGXGXGXGXGX[ GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXNXX.C.GXGXGXGXGXAX( GXGXGXGXGXGXGXGXGXGX@XR W W T K.GXGXGXGXGXGXAXGXGXGXKX3X&XGXGXGXGXGXGX>XGXNX*XB.GXGX3X| O.=XCXGXKXDX<XB.~ V.<XGXGXGXfX*X| | 4XKXGXGXGXGXGX&XZXGXGXGXGXGXGXGX2XI.).).).).).).).FXGXGXGXGXGXGXGX( GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXF GXDXGX",
"GXGXGX<XC.<XGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXW W W W [ GXGXGXGXGXKXKXGXGXGXKXGX[ GXGXGXGXGXGXGXGXGXKXGXGXGXGXGX<XM.[ ~ ( ~ | C.CXGXGXGXGXGXGXGXGX2Xc_C.GXGXGXGXZX..2XGXGXGXGXGXGXGXGX~ ).).).).).).).'.GXGXGXGXGXGXGXn.CXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXF DXGXGX",
"GXGXGXGXGXX.GXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGXW W W J GXGXGXGXGXGXGXGXGXGXGXGXCXB.GXGXGXGXGXGXGXGXGXGXGXGXGXGXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXN.N.GXGXGXKXJ.3XGXGXGXGXGXGXGXGX&X!.).).).).).).).GXGXGXGXGXGXGXC.;XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ DXGXGX",
"GXGXGXGXGXGX_ AXGXGXGX( ZXGXGXGXGXGXGXGXGXGXGXGX@XW W P -XGXGXGXGXGXGXGXGXGXGXGXGXB.NXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXV.V.GXGXKXK.KXGXGXGXGXGXGXGXGXGXj.).).).).).).).GXGXGXGXGXGXGX<XC.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ >XfXF ",
"GXGXGXGXGXGXGXN.GXGXGX[ fXGXGXGXGXGXGXGXGXGXGXGXKXq.W W | KXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXm.*XGXGXAX2XGXGXGXGXGXGXGXGXGX[ ).).).).).).).kXGXGXGXGXGXGXZXn.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX/ | ` GX",
"GXGXGXGXGXGXGX;X-XGXGX| 2XGXGXGXGXGXGXGXGXGXGXGXKXAX! W J >XGXGXGXGXAXGXGXGXGXGXGXGXCXO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX` DXGXNX-XKXGXGXGXGXGXGXGXGX;X!.).).).).).).'.DXGXGXGXGXGXGX[ GXGXGXGXGXGXGXGXGXGXGXGX>XGXm.~ GXGXKX",
"GXGXGXGXGXGXGXGXB.fXGX| >XGXGXGXGXGXGXGXGXGXGXGXGXGXSXW P | 2XGXGXGXKXKXGXGXGXGXGXGXGX=XJ.GXKXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX2Xn.KXGXK.GXGXGXGXGXGXGXGXGXKXl.).).).).).).(.GXGXGXGXGXGXGXF HXGXGXGXGXGXGXGXAXGXZXV.m.~ *X~ GXGXGX",
"GXGXGXGXGXGXGXGXGXO.C.n.=XGXGXGXGXGXGXGXGXGXGXGXGXGXGX6XR ` >X3XGXGXGXGXGXGXGXGXGXGXGXGXJ.&XGXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXKXO.CX<XB.GXGXGXGXGXGXGXGXGXGX/ ).).).).).).~.GXGXGXGXGXGXGX[ GXGXGXGXGXGXGX2XC.C.n.*XCXZXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXK.~ *XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXOXU 2XJ.GXGXGXGXGXGXGXGXGXGXGXGXGXB.&XKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX4XM.&XJ.GXGXGXGXGXGXGXGXGXGXO.).).).).).).~.GXGXGXGXGXGXGXn.GXGXGXGXCXV.2XJ.J.B.;XCXGXGXGX/ AXKXGX",
"GXGXGXGXGXGXGXGXGXGXGXB.K.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXSXT n.GXK.2XGXGXGXGXGXGXGXGXGXGXGXGXB.V.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX4XfX( >XAXKXGXGXGXGXGXGXGXGXGX=X~.).).).).).`.kXGXGXGXGXGXGXV.CXCX4X=X| B.O.K.CXKXAXGXGXGXGX/ AXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXV.[ CXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXG BXGX<X<XKXGXGXGXGXKXGXGXGXGXGXGX&XO.KXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX[ O.( | GXGXGXGXGXGXGXGXGXGXGXZXR.).).).).).].FXGXGXGXGXGXAXK.*XN.~ J.;XAX2XKXGXGXGXGXGXGXGX( AXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXC.m.B.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXL.V.GXGX>X&XGXGXGXGXKXAXGXGXGXGXGXGX2X~ 2XKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXNX*XK.K.J.K.M.( GXGXGXGXGXGXGXGXGXGXGXGXl.).).).~.`.kXGXGXGXGXGXGX4X| ~ V.fX*XZXGXGXGXGXGXGXGXGXGXGX^ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXJ.N.4XO.KXGXGXGXGXGXGXGXGXGXGXGXGXGXGXDXF AXAXGXGX[ AXKXKXGXGXGXGXGXGXGXGXGXKXO.M.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<XC.C.*X<X<XGXGXDX/ KXGXGXGXGXGXGXGXGXGXGXGXf.).).).~._.HXGXGXGXGXBX<X` O.C.ZXGXKXGXGXGXGXGXGXGXGXGXGXGX^ AXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXK.M.GXNXC.GXGXGXGXGXGXGXGXGXGXGXGXGXGXDXV.J.GXGXGXKX&X=XZXGXGXGXGXGXGXGXGXGXKXKX;X^ K.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ <XAXGXGXGXGXGXGX| KXKXGXGXGXGXGXGXGXGXGXGX/ (.).).~.cXGXGXGXGX3X[ J.-X4XK.GXGXKXKXGXGXGXGXGXGXGXGXGXKX( GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX&Xm.GXGX;X<XGXGXGXGXGXGXGXGXGXGXGXGXGXGXfX_ KXGXGXGXGX3Xm.J.KXGXGXGXGXGXGXGXGXGXGXGXJ.^ K.GXGXGXGXGXGXGXGXGXGXGXGXGX4XJ.C.4XKXGXGXGXGXGXGXGXN.AXGXGXGXGXGXGXGXGXGXGXGX( ).).).zXHXGXGXDXAXV.K.B.BXfXC.GXGXGXGXGXGXGXGXGXGXGXGXKXKX~ DXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX&XO.GXGXGXV.>XGXGXGXGXGXGXGXGXGXGXGXGXGXGXm.&XGXGXGXGXKXKXKXM.&XGXGXGXGXGXGXGXGXGXGXGXAXB.~ V.4XGXGXGXGXGXGXGXDXZXC.O.;XZXGXGXGXGXGXGXGXGXGX*X3XGXGXGXGXGXGXGXGXGXGXKX[ ).).'.DXGXGXGX*X<XC.AXfXGXCXV.GXGXGXGXGXGXGXGXGXGXGXGXKXKX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX&XO.GXGXGXGXB.*XGXGXGXGXGXGXGXGXGXGXGXGXGX>X[ AXKXGXGXGXGXGXGXGXN.V.GXGXGXGXGXGXGXGXGXGXGXBXV.~ M.<XKXKXGXCX*X( K.KXGXGXGXGXGXGXGXGXGXGXGXGX;X>XGXGXGXGXGXGXGXGXGXGXGX..).).kXGXGXGXKXC.( >XGXGXGXCXB.GXGXGXGXGXGXGXGXGXGXGXGXGXGX~ AXKXKX",
"GXGXGXGXGXGXGXGXGXGXGX&XO.GXGXGXGXGX*X| GXGXGXGXGXGXGXGXGXGXGXGXKXO.&XKXGXGXGXGXGXGXGXGXGX=XM.<XCXGXGXGXGXGXGXGXGXGX4XN.~ B.4X=XX.AXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<X-XGXGXGXGXGXGXGXGXGXGXGX..~.).HXGXKXGX&XC.*XGXGXGXGXZXB.GXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXAXKX",
"GXGXGXGXGXGXGXGXGXGXGX|.O.GXGXGXGXGXGXBXO.AXGXGXGXGXGXGXGXGXGXGXKX&X..KXGXGXGXGXGXGXGXGXGXGXGXZX<XV.^ [ C.O.J.K.&XL.V.N.c_| / N.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<X;XGXGXGXGXGXGXGXGXGXGXGX..~.zXGXKXKXJ.[ fXGXGXGXGXGXCXV.GXGXGXGXGXGXGXGXGXGXGXGXGXGX~ KXKXKX",
"GXGXGXGXGXGXGXGXGXGXGXC.n.GXGXGXGXGXGXGXGXJ.GXGXGXGXGXGXGXGXGXGXKXCX` ;XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAXGXZXGXGXKX4Xn.c_-XKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<X>XGXGXGXGXGXGXGXGXGXGXGX| _.GXGXKX*X[ <XGXGXGXGXGXGXCXV.GXGXGXGXGXGXGXGXGXGXGXGXGXGX~ AXGXKX",
"GXGXGXGXGXGXGXGXGXGXGXC.n.GXGXGXGXGXGXGXGXfXV.GXGXGXGXGXGXGXGXGXGXGXB.m.KXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX2X| O.4XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX-X3XGXGXGXGXGXGXGXGXGXGXGX[ lXGXGXCX[ <XGXGXGXGXGXGXGXNXC.KXGXGXGXGXGXGXGXGXGXGXGXGXGX~ AXKXKX",
"GXGXGXGXGXGXGXGXGXGXGXC.m.GXGXGXGXGXGXGXGXGXfX` AXGXGXGXGXGXGXGXGXGX;X^ 3XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX*X~ &XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.ZXGXGXGXGXGXGXGXGXGXGXKX~ FXGX3X*X;XGXGXGXGXGXGXGXGX3X&XKXGXGXGXGXGXGXGXGXGXGXGXGXGX~ KXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXC.N.GXGXGXGXGXGXGXGXGXGXZXO.CXGXGXGXGXGXGXGXGXNXc_&XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCXO.M.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXm.GXGXGXGXGXGXGXGXGXGXGXGX_ KXAX..J.KXGXGXGXGXGXGXGXGX<X*XGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXV.B.GXGXGXGXGXGXGXGXGXGXGXGXC.fXGXGXGXGXGXGXGXGXM. .1XZXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXB.X.AXGXGXGXGXGXGXGXGXGXGXGXGXGXGX[ GXGXGXGXGXGXGXGXGXGXGXGXO.KX;XV.2XKXGXGXGXGXGXGXGXGX-X;XGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXB.C.GXGXGXGXGXGXGXGXGXGXGXGXGX*X( 3XGXGXGXGXGXGXK.` P.aXaXDXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXJ.c_ZXGXGXGXGXGXGXGXGXGXGXGXGXGXGX[ GXGXGXGXGXGXGXGXGXGXGXGXV.DXB.GXAXGXGXGXGXGXGXGXGXGX&X2XGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXm.C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXN.*XGXGXGXGXGX-XF H.aXaXaX1XaXhXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXK.| AXGXGXGXGXGXGXGXGXGXGXGXGXGXGXN.GXGXGXGXGXGXGXGXGXGXKXZX*X<X2XGXGXGXGXGXGXGXGXGXGXGXV.4XGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXn.C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<XB.ZXGXGXGX>X( G.aXaXaXaXaXaXaXgXHXHXKXKXGXGXGXKXGXGXGXGXGXGXGXGXGXGXJ.X.GXGXGXGXGXGXGXGXGXGXGXGXGXGX-X<XGXGXGXGXGXGXGXGXGXGXGX;X..J.GXGXGXGXGXGXGXGXGXGXGXGXM.AXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXO.*XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXV.fXGXHX<X` G.aXaXaXaXaXaXaXaX1XaXaXaXhXDXDXKXGXGXGXGXGXGXGXGXGXGXN.N.GXGXGXGXGXGXGXGXGXGXGXGXGXGXO.GXGXGXGXGXGXGXGXGXGXGXGXB.M.4XGXGXGXGXGXGXGXGXGXGXGXGXO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX| ;XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX*X-XGX<X` G.aXaXaXaXaXaXaXaXaXaXaXaXaXaXaXsXgXsXaXgXhXDXDXhXsXgXc_*XGXGXGXGXGXGXGXGXGXGXGXGXGXGX` GXGXGXGXGXGXGXGXGXGXGXGX( DXKXGXGXGXGXGXGXGXGXGXGXGXGX` GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGXc_<XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXHXGXGXGXGXfXC.K.( G.aXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXP.aXaXaXaXaXaXP.~ 4XGXGXGXGXGXGXGXGXGXGXGXGXGX4XK.GXGXGXGXGXGXGXGXGXGXGXC.| GXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"GXGXGXGXGXGXGXGXGXGXGX[ 2XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.~ K.hXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXG.O.GXGXGXGXGXGXGXGXGXGXGXGXGXGXm.GXGXGXGXGXGXGXGXGXGXGX*XN.K.GXGXGXGXGXGXGXGXGXGXGXGXGXGX[ KXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGX",
"  GXGXGXGXGXGXGXGXGXGX` 4XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.c_L.J.>XjXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXc_=XGXGXGXGXGXGXGXGXGXGXGXGXGXGX` GXGXGXGXGXGXGXGXGXGX>X/ -XBXGXGXGXGXGXGXGXGXGXGXGXGXGXGXO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGX  ",
"      GXGXGXGXGXGXGXGX( fXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXAXn.O.ZXGX2XB.;XGXgXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaXH.[ GXGXGXGXGXGXGXGXGXGXGXGXGXGX;X-XGXGXGXGXGXGXGXGXGXCX*X<XO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXfXV.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~       ",
"          GXGXGXGXGXGX( ZXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX2X[ C.GXGXGXGXJ.| 4XDXZXsXaXaXaXaXaXaXaXaXaXaXaXaXaXaXaX .K.GXGXGXGXGXGXGXGXGXGXGXGXGXGX[ GXGXGXGXGXGXGXGXGXAXV.GXGX[ GXGXGXGXGXGXGXGXGXGXGXGXGXGX;X*XGXGXGXGXGXGXGXGXGXGXGXGXGXGX          ",
"              GXGXGXGX~ ZXKXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXKXGXC._ >XGXGXGXGXGX4XB.K.<X3X1XsXaXaX1XaXaXaXaXaXaXaXaXaXH.c_GXGXGXGXGXGXGXGXGXGXGXGXGXGXBXB.GXGXGXGXGXGXGXGXGXN.GXGXAXK.GXGXGXGXGXGXGXGXGXGXGXGXGXGXC.<XGXGXGXGXGXGXGXGXGXGXGXGX              ",
"                  GXGX~ DXKXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXKXAXn.n.AXGXGXGXGXGXGXGXZXfX<XO.J.HXGXhXaXaXaXaXaXaXaXaXaXc_-XGXGXGXGXGXGXGXGXGXGXGXGXGXGXO.GXGXGXGXGXGXGXGXZXN.>XGXGXC.AXGXGXGXGXGXGXGXGXGXGXGXGXGXGXm.CXGXGXGXGXGXGXGXGXGXGX                  ",
"                      ~ DXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX>X/ *XGXGXGXGXGXGXGXGXGXGXGXBXK.C.C.fXHXDXsXaXP.aXaXaXG.O.GXGXGXGXGXGXGXGXGXGXGXGXGXGXAXn.GXGXGXGXGXGXGXGXN.m.GXGXGX( GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX[ GXGXGXGXGXGXGXbXGX                      ",
"                          GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXB.| CXGXGXGXGXGXGXGXGXGXGXGXGXGXGXK.n.;XL.L.AXsXsXgXP._ CXGXGXGXGXGXGXGXGXGXGXGXGXGXGXn.ZXGXGXGXGXGXGXGXn.GXGXGXGXGXM.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGX.XpX                          ",
"                            . pXGXKXGXGXGXGXGXGXGXGXGXGXGXGXGXGX4X[ C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX3X4XCXX.J.;XGXDX1X1XGXGXGXGXGXGXGXGXGXGXGXGXGXGXZXn.GXGXGXGXGXGXGXC.2XGXGXGXGX*X4XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX[ GXGXGXA.F.O                             ",
"                              o % .XGXGXGXGXGXGXGXGXGXGXGXGXGXGXC.[ fXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXfX;X| *Xm.O.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXO.GXGXGXGXGXGXGX<X-XGXGXGXGXGX` GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXCXO.GX,.=.*                     UX          ",
"                                  $ 4 F.GXGXGXGXGXGXGXGXGXGXGXCX| C.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX;XN./ CX4X4XKXGXGXGXGXGXGXGXGXGXGXGXfXm.GXGXGXGXGXZX[ <XGXGXGXGXGXGXm.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<XN A 2                         UX          ",
"              UX                      < p A.GXGXGXGXGXGXGXGXGX=X( 3XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXc_~ O.C.V.GXGXGXGXGXGXGXGXGXGXGXGX[ GXGXGXGXGXfXC.;XGXGXGXGXGXKXK.4XGXGXGXGXGXGXGXGXGXGXGXGXGXGXd_i =                           UXUXUX        ",
"              UX                          4 c A.GXGXGXGXGXGXGXm.m.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXHXN.B.KXAX3X[ -XNXGXGXGXGXGXGXGXGXGX;XC.GXGXGXGXZX| GXGXGXGXGXGXGXGX( GXGXGXGXGXGXGXGXGXGXGXGXZXAXq 0                           UXUXUXUXUXUXUX    ",
"            UXUXUX                            6 S A.GXGXGXKX4X( -XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX*X..GXGXKXGX*XC.*XGXZXGXGXGXGXGXGXGX~ GXGXGXGXAXn.GXGXGXGXGXGXGXGXZXN.GXGXGXGXGXGXGXGXGXGXpXKX> 5                                   UXUXUX        ",
"        UXUXUXUXUXUXUX                            4 =.d_AXGX&X| GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX3XF 4XGXGXGXGXCX=X[ [ <XGXGXGXGXGXGXV.;XGXGXNXV.L.GXGXGXGXGXGXGXGXGXV.fXGXGXGXGXGXGXGXGXpXNX4 2                                         UX          ",
"            UXUXUX                                    > A.,XO.V.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX| *XGXGXGXGXGXGXCXGXV.C.fXGXGXGXGXZX| GXGXCXm.C.GXGXGXGXGXGXGXGXGXGX~ GXGXGXGXGXGXGXBX,Xd ;                                             UX          ",
"              UX                  UX                      X M *XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXB.N.GXGXGXGXGXGXGXGXGX<XC.*XGXGXGXGX| CXGXpXN.GXGXGXGXGXGXGXGXGXGXGX2XV.GXGXGXGXGXGXoXb $                                                             ",
"              UX                UXUXUX                          *.BXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX;Xc_GXGXGXGXGXGXGXGXGXGXGX*XO.GXZXGX;XB.GXC.<XGXGXGXGXGXGXGXGXGXGXGXGXn.ZXGXGXGXGX,X&.$ X               $                                               ",
"                                  UX                                S BXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXZX( <XGXGXGXGXGXGXGXGXGXGXGX2Xn.F <XGX~ C.B.4XGXGXGXGXGXGXGXGXGXGXGXGXGX` GXGXGXpXA.$ o                 # IX.                                             ",
"                                                    9X>                 v pXGXGXGXGXGXGXGXGXGXGXGXGXGXN.V.GXGXGXGXGXGXGXGXGXGXGXGXZXBX*XC.m.| C.ZXGXGXGXGXGXGXGXGXGXGXGXGXGX;XK.GXGX.X* $                     PXUXUX                                            ",
"                                                    IX$                     j .XpXGXGXGXGXGXGXGXGXGX;X[ GXGXGXGXGXGXGXGXGXGXGXGXGXGXDXAX` [ GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXO.ZX,X2 &                           UX                UX                            ",
"                                                  UXUXIX+                       s D..XGXGXGXGXGXGXGX| -XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXn.<XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXC 0 ,                                                 UX                            ",
"                                              UXUXUXUXUXUXIX$                       p <.S.GXGXGXGX&XO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX3XO.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGX,Xr -                                                     UXUX                          ",
"                            UX                    UXUXUX                      > +..     y D >.GXGX[ <XGXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX| 4XGXGXGXGXGXGXGXGXGXGXGXGXGX.Xl 4               > o                                     UXUXUXUX                        ",
"            UX              UX                      UX                      x 9XLX+.        e b V O.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXGX<XO.GXGXGXGXGXGXGXGXGXGXGXGX XA 3                   7.8                                   UXUXUXUXUXUXUXUX                  ",
"          UXUXUX          UXUXUX                    UX                      $ 6.@.&             : r <.GXGXGXGXGXGXGXGXGXGXGXGXGXGXGXX.2XGXGXGXGXGXGXGXGXGXGXb_&.<                     $ 0X>                               UXUXUXUXUXUXUXUX                      ",
"            UX        UXUXUXUXUXUXUX                                          # . $.g               0 e D.GXGXGXGXGXGXGXGXGXGXGXGX4Xc_GXGXGXGXGXGXGXGXGXb_,.$                     # # LXUXUX                                    UXUXUXUX                        ",
"                          UXUXUX                                                  8X7                 . 3 3 pXGXGXGXGXGXGXGXGXGXGXB.*XGXGXGXGXGXGXGX Xb_                          0XIXUXUXUXUXUX                                  UXUX                          ",
"                            UX                                                  PXUXIX<                   X * w GXGXGXGXGXGXGXGXGX/ ZXGXGXGXKXGXoX,.                                  UXUXUX                                      UXUX                        UX",
"                            UX                                              UXUXUXUXUXIXIX&                   . # j GXGXGXGXGXGX<X| GXGXGXGXpXS             o .                         UX                                          UX                      UXUX",
"                                                                                UXUXUX                            . o S GXGXGXGXC.K.KXGXAXk               o 9X<                         UX                              UX                                    UX",
"                                                UX                                UX                                      ,.GXGXO.<XGX0                   LXUXUX.                                                     UXUXUX                                    ",
"                                              UXUXUX                              UX                                          oX[ O                         UX                                                          UX                                      ",
"                                                UX                                                                                                                                                                                                              "
};
    }

    set minkoIcon24 {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 138 2",
"   c Gray0",
".  c #080504",
"X  c #0e0906",
"o  c #0b0b0b",
"O  c #120c08",
"+  c #17100b",
"@  c #1b130d",
"#  c Gray7",
"$  c Gray11",
"%  c #20160f",
"&  c #261a12",
"*  c #2d1f15",
"=  c #312117",
"-  c #35261b",
";  c #39271b",
":  c #3f2b1d",
">  c #2c2c2c",
",  c Gray21",
"<  c #3a3a3a",
"1  c #402c1e",
"2  c #412e20",
"3  c #473021",
"4  c #573b29",
"5  c #593d2a",
"6  c #60422d",
"7  c #6c4a33",
"8  c #734e36",
"9  c #745037",
"0  c #7a563c",
"q  c Gray28",
"w  c Gray29",
"e  c #5a5a5a",
"r  c Gray39",
"t  c #6c6c6c",
"y  c #28aa18",
"u  c #37af24",
"i  c #38af25",
"p  c #3ab027",
"a  c #6f9837",
"s  c #6dc250",
"d  c #78c659",
"f  c Cyan",
"g  c #19e8eb",
"h  c #10f4f1",
"j  c #39dace",
"k  c #36ddd1",
"l  c #29e5dc",
"z  c #2cfdf5",
"x  c #66a6b2",
"c  c #71c1ba",
"v  c #45d3c4",
"b  c #73fae5",
"n  c #82593d",
"m  c #84654a",
"M  c #9a6a49",
"N  c #9e7d5d",
"B  c #a5714e",
"V  c #a67b58",
"C  c #aa7450",
"Z  c #af7853",
"A  c #b47b55",
"S  c #e636bc",
"D  c Magenta",
"F  c #ff17f9",
"G  c #ec28cd",
"H  c #ff26f6",
"J  c #ff3af1",
"K  c #df45a9",
"L  c #dd49a4",
"P  c #e474aa",
"I  c #f04dcd",
"U  c #ff6ee5",
"Y  c #9a8e4a",
"T  c #9d914d",
"R  c #a78b50",
"E  c #ac8a52",
"W  c #b68756",
"Q  c #be835a",
"!  c #b8915e",
"~  c #ab8765",
"^  c #ac8865",
"/  c #b48d68",
"(  c #bd9a75",
")  c #b3b06e",
"_  c #97d173",
"`  c #c2855c",
"'  c #c4885f",
"]  c #c58163",
"[  c #c58b62",
"a_ c #c89066",
"b_ c #ca946a",
"|  c #cc986e",
" . c #ce9c72",
".. c #d1a176",
"X. c #d4a77c",
"o. c #d6aa7f",
"O. c #8aa88b",
"+. c #95a182",
"@. c Gray71",
"#. c #b9b9b9",
"$. c #b5d083",
"%. c #b2db88",
"&. c #8cfae0",
"*. c #d6ac81",
"=. c #d8ae83",
"-. c #d3b48b",
";. c #dab287",
":. c #dcb589",
">. c #deb98d",
",. c #e1be92",
"<. c #ffafd6",
"1. c #ded7ba",
"2. c #e3c296",
"3. c #e5c69a",
"4. c #e6c99c",
"5. c #e8cc9f",
"6. c #eacea1",
"7. c #ecd3a5",
"8. c #edd6a9",
"9. c #efd9ab",
"0. c #f7cfbf",
"q. c #f1dbae",
"w. c #f1ddb0",
"e. c #f4e3b5",
"r. c #f7e7b9",
"t. c #f7e8b9",
"y. c #f9ebbd",
"u. c Gray79",
"i. c Gray83",
"p. c #ffd4cf",
"a. c #f4ecc2",
"s. c #fbefc0",
"d. c #fff6c7",
"f. c #fff0c8",
"g. c Gray89",
"h. c #e9e9e9",
"j. c Gray100",
"k. c None",
/* pixels */
"`         j.    j.                  j.        ` ",
"` ` `     j.  j.j.g.      , j.h.          ` ` d.",
"d.d.` ` `     , @.#       #.i.r . X . Q ` d.` d.",
"d.d.` d.d.A 8 > .   t q   * 4 8 A | ;.d.d.d.` d.",
"d.d.` d.d.8.m ;   # $ O ( q.6.' 2.d.d.d.d.d.Q d.",
"` d.` u _ d.` O . . C e.d.4.' 3.a.1.t.d.y.t.` Q ",
"d.` Q y d t.,.7   *.d.d.9.[ O.k l h g x c +.Q d.",
"d.d.W y u ) 8.V 0 d.d.;.=.| +.k z z f f f j [ d.",
"d.d.E y y T 9./ ,.d. .d.d.0.P ] 5.d.d.&.b v b_d.",
"d.f.! y y R d.;.7.s.e.d.U F D D L  .=.t.y.6.b_d.",
"d.f.b__ y Y d.e.3.d.9.f.p.H D D D L X.>.>.=.' e.",
"Q s.b_d.u a d.d.a_e.9.d.>.b_[ S D D Q e.8.7.'  .",
"d...' d.%.y 9.d.7.2.=.t.` r.d.3.G H I d.d.f.` d.",
"d.9.Q f.d.s Q y.d.3.` [ [ y.d.d.a_D p.,.d.d.a_d.",
"d.d.a_:.d.d.$.[ e.y.w.6.3.d.d.s.o.J d...d.d.| f.",
"d.d.b_>.b_d.d.3.;.4.b_4.d.d.d.o.' <.d.b_d.t.b_t.",
"Q d.b_5.d.>.t.d.5.[ 2.t.d.d.8.2.o.d.d...>.2.a_Q ",
"  Q ` 7.d.d.6. .6.3.| | =.;.,.e.[ d.d. .Z 0 B   ",
"    . / 7.d.d.d.d.t.;.[ 9.d.d.d.5.e.-.Z : @     ",
"      X : ~ y.d.d.3.[ 3.d.d.d.b_d.Q : *   #     ",
"    j.    & 7 M Q [ 6.r.d.d.,.;.~ 2 e     j.    ",
"  j.j.j.      @ 4 6 N *.=.7.Z n   w < o   j.    ",
"    j.        u.q X % - ` M   # o     j.j.j.j.j.",
"            j.j..           . h..         j.    "
};    }


    set minkoIcon24b {
/* XPM */
static char * minko3_xpm[] = {
"24 24 8 1",
" 	c #C2C285855C5C",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #FFFFF6F6C7C7",
"O	c #2828AAAA1818",
"+	c #8A8A87879898",
"@	c #0000FFFFFFFF",
"#	c #FFFF0000FFFF",
" ....X..X.........X.... ",
"   ..X.XXX....XX.....  o",
"oo   ...X.....XX...  o o",
"oo oo  .....X....  ooo o",
"oo oooo  ......   oooo o",
" o OOoo o  ..  oo oooo  ",
"o  OOOO ooo  oooo ooo  o",
"oo OOOO oooo oooo o++@ o",
"oo OOOO oooo oooo  @@@ o",
"oo ooOO  ooo oo   @@@@ o",
"oo oooo o  o   oo @@@o o",
" o oooo ooo  oooo @ooo  ",
"o  oooo oooo oooo ooo  o",
"oo   oo oooo oo## o  o o",
"oo oo   oooo ####  ooo o",
"oo oooo  ooo #### oooo o",
" o oooo o  o #### oooo  ",
".  oooo ooo  ##oo ooo  .",
"...  oo oooo oooo o  ...",
".....   oooo oooo  .....",
"..X....  ooo oo  ....X..",
".XXX.....  o   ..X...X..",
"..X....X...  ......XXXXX",
"......XX.......X.....X.."};    }

    set minkoIcon24a {
/* XPM */
static char * minko2_xpm[] = {
"24 24 7 1",
" 	c #8A8A87879898",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #C3C3D9D9F6F6",
"O	c #FFFFF0F0A0A0",
"+	c #0000FFFFFFFF",
"@	c #FFFF0000FFFF",
" ........X.....X...X... ",
"   ..X..X....X...X...  o",
"oo   ......X..X....  o o",
"oo oo  ..X...X...  ooo o",
"oo oooo  ......   oooo o",
" o OOoo o  ..  oo oooo  ",
"o  OOOO ooo  oooo ooo  o",
"oo OOOO oooo oooo o  + o",
"oo OOOO oooo oooo  +++ o",
"oo ooOO  ooo oo   ++++ o",
"oo oooo o  o   oo +++o o",
" o oooo ooo  oooo +ooo  ",
"o  oooo oooo oooo ooo  o",
"oo   oo oooo oo@@ o  o o",
"oo oo   oooo @@@@  ooo o",
"oo oooo  ooo @@@@ oooo o",
" o oooo o  o @@@@ oooo  ",
".  oooo ooo  @@oo ooo  .",
"...  oo oooo oooo o  ...",
".....   oooo oooo  ...X.",
".X.....  ooo oo  .......",
"......X..  o   ...X.X...",
"....X......  ...X......X",
"...................X...."};
    }

    set OptMenuPullXPM {
/* XPM */
static char * pull_xpm[] = {
"24 19 4 1",
" 	c none",
".	c #F8F8FCFCF8F8",
"X	c #78787C7C7878",
"o	c #D0D0D0D0D0D0",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"     ...............    ",
"     ..............X    ",
"     ..oooooooooooXX    ",
"     ..XXXXXXXXXXXXX    ",
"     .XXXXXXXXXXXXXX    ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        "};
}
set OptMenuPullImg [image create pixmap -data $OptMenuPullXPM]

    set up12Icon {
/* XPM */
static char * up_xpm[] = {
"12 12 3 1",
" 	c #D3D3D3D3D3D3",
".	c #000000000000",
"X	c #FFFFAEAE1A1A",
"            ",
"     ..     ",
"    .XX.    ",
"   .XXXX.   ",
"  .XXXXXX.  ",
" ...XXXX... ",
"   .XXXX.   ",
"   .XXXX.   ",
"   .XXXX.   ",
"   .XXXX.   ",
"   ......   ",
"            "};
}
set down12Icon {
/* XPM */
static char * down_xpm[] = {
"12 12 3 1",
" 	c #D3D3D3D3D3D3",
".	c #000000000000",
"X	c #FFFFAEAE1A1A",
"            ",
"   ......   ",
"   .XXXX.   ",
"   .XXXX.   ",
"   .XXXX.   ",
"   .XXXX.   ",
" ...XXXX... ",
"  .XXXXXX.  ",
"   .XXXX.   ",
"    .XX.    ",
"     ..     ",
"            "};
}
    set up10Icon {
/* XPM */
static char * up_xpm[] = {
"10 14 3 1",
" 	c #D3D3D3D3D3D3",
".	c #000000000000",
"X	c #FFFFAEAE1A1A",
"          ",
"          ",
"    ..    ",
"   .XX.   ",
"  .XXXX.  ",
" .XXXXXX. ",
"...XXXX...",
"  .XXXX.  ",
"  .XXXX.  ",
"  .XXXX.  ",
"  .XXXX.  ",
"  .XXXX.  ",
"  ......  ",
"          "};
}
set down10Icon {
/* XPM */
static char * down_xpm[] = {
"10 14 3 1",
" 	c #D3D3D3D3D3D3",
".	c #000000000000",
"X	c #FFFFAEAE1A1A",
"          ",
"          ",
"  ......  ",
"  .XXXX.  ",
"  .XXXX.  ",
"  .XXXX.  ",
"  .XXXX.  ",
"  .XXXX.  ",
" ..XXXX...",
" .XXXXXX. ",
"  .XXXX.  ",
"   .XX.   ",
"    ..    ",
"          "};
}
set done12Icon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"12 12 32 1",
"  c #1fd700",
". c #26d700",
"X c #2cd700",
"o c #34d702",
"O c #3dd706",
"+ c #3dd70a",
"@ c #4bd717",
"# c #5ed731",
"$ c #5fd836",
"% c #67d83e",
"& c #69d73f",
"* c #6bd84a",
"= c #71d84a",
"- c #7cd865",
"; c #8cd86e",
": c #8ed871",
"> c #94d87b",
", c #aed89d",
"< c #b3d9a6",
"1 c #b7d8aa",
"2 c #b9d8aa",
"3 c #c9d9c4",
"4 c #ced9ca",
"5 c #d1d9ce",
"6 c #d6d9d6",
"7 c #d8d9d7",
"8 c Gray85",
"9 c #ded9e1",
"0 c #e2d9e4",
"q c #e6d9eb",
"w c #e9d9ed",
"e c #f1d9fa",
/* pixels */
"88888888867w",
"88888888880<",
"8888778686#$",
"8886866q,O.1",
"858866q,oo,0",
"3@&689,oo,q6",
"8= O17+o,q68",
"08;o*;.,q678",
"66e;Xo&06788",
"8684@X>q6788",
"886q-.487888",
"8769<:688888"
};
}
set open12Icon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"12 12 29 1",
"  c #b60000",
". c #b80002",
"X c #bc001b",
"o c #bc0021",
"O c #bd0c27",
"+ c #bf0d2d",
"@ c #bd1025",
"# c #c32a46",
"$ c #c32d49",
"% c #c6425a",
"& c #c96174",
"* c #cb6c7c",
"= c #cc7686",
"- c #cc7a87",
"; c #cf8e99",
": c #d19da7",
"> c #d3a6ae",
", c #d5bec2",
"< c #d6c2c6",
"1 c #d7cacd",
"2 c #d8cfd1",
"3 c #d9d5d5",
"4 c #d9d7d8",
"5 c #d9dada",
"6 c #dae0df",
"7 c #dae5e3",
"8 c #dbe9e6",
"9 c #dbebe8",
"0 c #dcf0ed",
/* pixels */
"554448743445",
"45455,<56454",
"4453%*%#>644",
"448- ;5X@254",
"5451=15+@154",
"444570;X:644",
"54545;#>8354",
"45452$483545",
"54452&:64545",
"4539* @15454",
"5446:X%54545",
"455462554454"
};}
set up12Img   [image create pixmap -data $up12Icon]
set down12Img [image create pixmap -data $down12Icon]
set up10Img   [image create pixmap -data $up10Icon]
set down10Img [image create pixmap -data $down10Icon]
set done12Img [image create pixmap -data $done12Icon]
set open12Img [image create pixmap -data $open12Icon]

set weekCalIcon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 6 1",
"  c Gray0",
". c #151515",
"X c #f0a0ff",
"o c #fff0a0",
"O c Gray100",
"+ c None",
/* pixels */
" ... ... ... ....... .. ",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
"                        ",
" OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
".OOO ooo OOO OOO OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO OOO OOO XXX OOO OO.",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
" ... ... ... ... ... .. "
};
}
    set multiUserGroupCalIcon {
/* XPM */
static char * multiCal_xpm[] = {
"24 24 8 1",
" 	c #D3D3D3D3D3D3",
".	c #000000000000",
"X	c #B3B3B3B3B3B3",
"o	c #F2F2F2F2F2F2",
"O	c #FFFFF8F8DCDC",
"+	c #F0F0A0A0FFFF",
"@	c #FFFFF0F0A0A0",
"#	c #A0A0FFFFF0F0",
"                        ",
"         . .. .         ",
"........................",
".Xoo.oo.OO.oo.oo.++.ooX.",
".Xoo.oo.OO.oo.@@.++.ooX.",
".Xoo.@@.OO.oo.##.++.ooX.",
".Xoo.@@.OO.oo.oo.oo.ooX.",
"........................",
"             .          ",
"         .... ..        ",
"........................",
".Xoo.oo.OO.oo.oo.oo.ooX.",
".X##.oo.OO.oo.@@.oo.ooX.",
".X##.oo.@@.oo.oo.##.ooX.",
".Xoo.oo.OO.oo.oo.oo.ooX.",
"........................",
"            .           ",
"          .. ...        ",
"........................",
".Xoo.oo.OO.oo.oo.oo.ooX.",
".Xoo.oo.++.oo.@@.oo.++X.",
".Xoo.oo.++.oo.oo.oo.ooX.",
".Xoo.oo.OO.oo.oo.oo.ooX.",
"........................"};
}

set multiUserGroupCalIcon_out  $multiUserGroupCalIcon
set multiUserGroupCalIcon_in   $weekCalIcon

set onlyCommonIcon {
/* XPM */
static char * cgroupCommonOnly_xpm[] = {
"24 24 8 1",
" 	c #B3B3B3B3B3B3",
".	c #F0F0A0A0FFFF",
"X	c #D8D8D0D0FAFA",
"o	c #A0A0FFFFF0F0",
"O	c #F2F2F2F2F2F2",
"+	c #DCDCFAFADCDC",
"@	c #FAFAD8D8D8D8",
"#	c #FFFFF0F0A0A0",
"       ......           ",
"     ....XXXXXX         ",
"    ..XXXXXXXXXooo      ",
"   ..XXXXXOOOOOOXoo     ",
"  ..XXXOOOOOOOOOO++o    ",
"  .XXXOOOOOOOOOOOO++o   ",
" .XXXOOOOOOOOOOOOOO++o  ",
" .XXOOOOOOOOOOOOOOO+++  ",
".XXOOOOOOOOOOOOOOOOO+++ ",
".XXOOOOOOOOOOOOOOOOO+++ ",
".X@OOOOOOOOOOOOOOOOO+++#",
".X@OOOOOOOOOOOOOOOOO+++#",
".X@OOOOOOOOOOOOOOOOO+++#",
"..@OOOOOOOOOOOOOOOOO++##",
"..@OOOOOOOOOOOOOOOOO++##",
"..@OOOOOOOOOOOOOOOOO+###",
" .@@OOOOOOOOOOOOOOOO####",
" ..@@OOOOOOOOOOOOOO#### ",
"  .@@@OOOOOOOOOOOO##### ",
"  ..@@@@@OOOOOO@@@####  ",
"   ..@@@@@@@@@@@@####   ",
"    ..@@@@@@@@@@####    ",
"     ..@@@@@@@@####     ",
"       ...######        "};

}
set onlyCommonIcon_in  {
/* XPM */
static char * atGroupsCommonOnly3_xpm[] = {
"24 24 7 1",
" 	c #B3B3B3B3B3B3",
".	c #4F4F53538F8F",
"X	c #5151A3A32E2E",
"o	c #474747474747",
"O	c #FFFFFFFFFFFF",
"+	c #616161616161",
"@	c #C7C788881414",
"                        ",
"                        ",
"                        ",
"       ..       XX      ",
"      .....   XXXXX     ",
"      ......oXXXXXX     ",
"     ......oO+XXXXXX    ",
"     ......oO+XXXXXX    ",
"    ......oOOOoXXXXXX   ",
"   .......oOOOoXXXXXXX  ",
"   ......oOOOOOoXXXXXX  ",
"  ......oOOOOOOOoXXXXXX ",
"  ......oOOOOOOOoXXXXXX ",
" ......oOOOOOOOOOoXXXXXX",
"   ....oOOOOOOOOOoXXXX  ",
"     .oOOOOOOOOOOOoX    ",
"      ooooooooooooo     ",
"      @@@@@@@@@@@@@     ",
"      @@@@@@@@@@@@@     ",
"      @@@@@@@@@@@@@     ",
"      @@@@@@@@@@@@@     ",
"      @@@@@@@@@@@@@     ",
"                        ",
"                        "};
}
set onlyCommonIcon_out {
/* XPM */
static char * atGroupsCommonOnly2_xpm[] = {
"24 24 6 1",
" 	c #B3B3B3B3B3B3",
".	c #424242424242",
"X	c #BDBDCCCCFFFF",
"o	c #CCCCFFFFA8A8",
"O	c #FFFFFFFFFFFF",
"+	c #FFFFEBEBB8B8",
"                        ",
"                        ",
"                        ",
"       ..       ..      ",
"      .XX.. . ..oo.     ",
"      .XXXX.O.oooo.     ",
"     .XXXXXOOOooooo.    ",
"     .XXXXXOOOooooo.    ",
"    .XXXXXOOOOOooooo.   ",
"   .XXXXXXOOOOOoooooo.  ",
"   .XXXXXOOOOOOOooooo.  ",
"  .XXXXXOOOOOOOOOooooo. ",
"  .XXXXXOOOOOOOOOooooo. ",
" .XXXXXOOOOOOOOOOOooooo.",
"  ...XXOOOOOOOOOOOoo... ",
"     .OOOOOOOOOOOOO.    ",
"      .+++++++++++.     ",
"      .+++++++++++.     ",
"      .+++++++++++.     ",
"      .+++++++++++.     ",
"      .+++++++++++.     ",
"      .............     ",
"                        ",
"                        "};
}


set dayCalIcon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 6 1",
"  c Gray0",
". c #151515",
"X c #f0a0ff",
"o c #fff0a0",
"O c Gray100",
"+ c None",
/* pixels */
" ...................... ",
".OOOOOOOOOOOOOOOOOOOOOO.",
".OOOOOOOOOOOOOOOOOOOOOO.",
".OOOOOOOOOOOOOOOOOOOOOO.",
"   oooooo               ",
".OOooooooOOOOOOOOOOOOOO.",
".OOooooooOOOOOOOOOOOOOO.",
".OOooooooOOOOOOOOOOOOOO.",
"   ooooooXXXXXX         ",
".OOooooooXXXXXXOOOOOOOO.",
".OOooooooXXXXXXOOOOOOOO.",
".OOooooooXXXXXXOOOOOOOO.",
"   ooooooXXXXXX         ",
".OOooooooXXXXXXOOOOOOOO.",
".OOooooooXXXXXXOOOOOOOO.",
".OOooooooXXXXXXOOOOOOOO.",
"         XXXXXX        .",
".OOOOOOOOXXXXXXOOOOOOOO.",
".OOOOOOOOXXXXXXOOOOOOOO.",
".OOOOOOOOXXXXXXOOOOOOOO.",
"                        ",
".OOOOOOOOOOOOOOOOOOOOOO.",
".OOOOOOOOOOOOOOOOOOOOOO.",
" ...................... "
};
}
set monthCalIcon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 6 1",
"  c Gray0",
". c #151515",
"X c #f0a0ff",
"o c #fff0a0",
"O c Gray100",
"+ c None",
/* pixels */
" ... ... ... ....... .. ",
".OOO OOO OOO OOO ooo OO.",
".OOO OOO OOO OOO ooo OO.",
".OOO OOO OOO OOO ooo OO.",
"                        ",
" OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
".OOO ooo OOO XXX OOO OO.",
"                        ",
".XXX OOO OOO OOO OOO OO.",
".XXX OOO OOO OOO OOO OO.",
".XXX OOO OOO OOO OOO OO.",
"                        ",
".OOO OOO XXX OOO OOO OO.",
".OOO OOO XXX OOO OOO OO.",
".OOO OOO XXX OOO OOO OO.",
"                        ",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
"                        ",
".OOO OOO OOO OOO OOO OO.",
".OOO OOO OOO OOO OOO OO.",
" ... ... ... ... ... .. "
};
}
set quitIcon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 25 1",
"  c #ff0101",
". c #ff0b0b",
"X c #ff1313",
"o c #ff1b1b",
"O c #ff2525",
"+ c #ff2c2c",
"@ c #ff3030",
"# c #ff3b3b",
"$ c #ff5252",
"% c #ff5c5c",
"& c #ff6565",
"* c #ff6e6e",
"= c #ff7676",
"- c #ff8181",
"; c #ff8989",
": c #ff9292",
"> c #ff9e9e",
", c #ffaaaa",
"< c #ffb7b7",
"1 c #ffc3c3",
"2 c #ffcfcf",
"3 c #ffd1d1",
"4 c #ffe0e0",
"5 c #ffefef",
"6 c Gray100",
/* pixels */
"666666666666666666666666",
"66;o>6666666666666666666",
"62<X o566666666666666666",
"6+ .O .56666666666666666",
"66=X X X666666666666;366",
"6666>.  X666666666=. -66",
"666665#  X666666;. X<666",
"6666666:  -6666X o366666",
"66666666,  265. 36666666",
"6666666661  5. 266666666",
"6666666666=  .2666666666",
"6666666666+  o6666666666",
"666666666O == %666666666",
"66666666X ;66% ;66666666",
"6666666X ,6666+ 56666666",
"666666& <666665 +6666666",
"666663 #6666666$ 5666666",
"66666o 566666666 O666666",
"6666* :666666666% 266666",
"6666.O66666666666.o66666",
"6666,366666666666> 26666",
"666666666666666666256666",
"666666666666666666666666",
"666666666666666666666666"
};
}

set ignoreIcon_in {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 7 1",
"  c #020202",
". c #151515",
"X c Gray1",
"o c Gray100",
"O c Red",
"+ c Gray0",
"@ c #fff0a0",
/* pixels */
" ......................X",
".oooooooooooooooooooooo.",
".oooOOOOOOOOOOOOOOooooo.",
".oooOOOOOOOOOOOOOOooooo.",
"++++OO@@@@@@@@@@OO++++++",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
"++++OO@@@@@@@@@@OO++++++",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
"++++OO@@@@@@@@@@OO++++++",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
"++++OO@@@@@@@@@@OO+++++.",
".oooOO@@@@@@@@@@OOooooo.",
".oooOO@@@@@@@@@@OOooooo.",
".oooOOOOOOOOOOOOOOooooo.",
"++++OOOOOOOOOOOOOO++++++",
".oooooooooooooooooooooo.",
".oooooooooooooooooooooo.",
"X......................X"
};
}
set ignoreInfoIcon_in {
/* XPM */
static char * ignoreInfo_in_xpm[] = {
"24 24 6 1",
" 	c #000000000000",
".	c #104014511040",
"X	c #FFFFFFFFFFFF",
"o	c #FFFF00000000",
"O	c #FFFFF3CEA699",
"+	c #00000000CF3C",
" ...................... ",
".XXXXXXXXXXXXXXXXXXXXXX.",
".XXXooooooooooooooXXXXX.",
".XXXooooooooooooooXXXXX.",
"    ooOOOOOOOOOOoo      ",
".XXXooOOOOOOOOOOooXXXXX.",
".XXXooOOOO++OOOOooXXXXX.",
".XXXooOOOO++OOOOooXXXXX.",
"    ooOOOOOOOOOOoo      ",
".XXXooOOO+++OOOOooXXXXX.",
".XXXooOOOO++OOOOooXXXXX.",
".XXXooOOOO++OOOOooXXXXX.",
"    ooOOOO++OOOOoo      ",
".XXXooOOOO++OOOOooXXXXX.",
".XXXooOOOO++OOOOooXXXXX.",
".XXXooOOO++++OOOooXXXXX.",
"    ooOOOOOOOOOOoo     .",
".XXXooOOOOOOOOOOooXXXXX.",
".XXXooOOOOOOOOOOooXXXXX.",
".XXXooooooooooooooXXXXX.",
"    oooooooooooooo      ",
".XXXXXXXXXXXXXXXXXXXXXX.",
".XXXXXXXXXXXXXXXXXXXXXX.",
" ...................... "};
}
set ignoreInfoIcon_out {
/* XPM */
static char * ignoreInfo_out_xpm[] = {
"24 24 8 1",
" 	c #000000000000",
".	c #104014511040",
"X	c #FFFFFFFFFFFF",
"o	c #FFFF00000000",
"O	c #96588E385965",
"+	c #FFFFF7DEC71B",
"@	c #86178617FFFF",
"#	c #86178207A699",
" ...................... ",
".XXXXXXXXXXXXXXXXXXXXXX.",
".XXXXoXoooXoooXooXXXXXX.",
".XXXooXoooXoooXoooXXXXX.",
"    ooOOOOOOOOOOoo      ",
".XXXXX++++++++++XXXXXXX.",
".XXXoo++++@@++++ooXXXXX.",
".XXXoo++++@@++++ooXXXXX.",
"    ooOOOOOOOOOOoo      ",
".XXXXX+++@@@++++XXXXXXX.",
".XXXoo++++@@++++ooXXXXX.",
".XXXoo++++@@++++ooXXXXX.",
"    ooOOOO##OOOOoo      ",
".XXXXX++++@@++++XXXXXXX.",
".XXXoo++++@@++++ooXXXXX.",
".XXXoo+++@@@@+++ooXXXXX.",
"    ooOOOOOOOOOOoo     .",
".XXXXX++++++++++XXXXXXX.",
".XXXoo++++++++++ooXXXXX.",
".XXXooXoooXoooXoooXXXXX.",
"     o ooo ooo oo       ",
".XXXXXXXXXXXXXXXXXXXXXX.",
".XXXXXXXXXXXXXXXXXXXXXX.",
" ...................... "};
}
set ignoreIcon $ignoreIcon_in
set ignoreIcon_out {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 7 1",
"  c Gray0",
". c #151515",
"X c Red",
"o c #958c5d",
"O c #fff6c7",
"+ c Gray100",
"@ c None",
/* pixels */
" ...................... ",
".++++++++++++++++++++++.",
".++++X+XXX+XXX+XX++++++.",
".+++XX+XXX+XXX+XXX+++++.",
"    XXooooooooooXX      ",
".+++++OOOOOOOOOO+++++++.",
".+++XXOOOOOOOOOOXX+++++.",
".+++XXOOOOOOOOOOXX+++++.",
"    XXooooooooooXX      ",
".+++++OOOOOOOOOO+++++++.",
".+++XXOOOOOOOOOOXX+++++.",
".+++XXOOOOOOOOOOXX+++++.",
"    XXooooooooooXX      ",
".+++++OOOOOOOOOO+++++++.",
".+++XXOOOOOOOOOOXX+++++.",
".+++XXOOOOOOOOOOXX+++++.",
"    XXooooooooooXX     .",
".+++++OOOOOOOOOO+++++++.",
".+++XXOOOOOOOOOOXX+++++.",
".+++XX+XXX+XXX+XXX+++++.",
"     X XXX XXX XX       ",
".++++++++++++++++++++++.",
".++++++++++++++++++++++.",
" ...................... "
};
}

set helpIcon {
/* XPM */
static char * help_xpm[] = {
"24 24 4 1",
" 	c grey98",
".	c #C78814",
"X	c #FFEBB8",
"o	c #009800",
"                        ",
"         ......         ",
"       ..........       ",
"     ....XXXXXX....     ",
"    ...XXXXXXXXXX...    ",
"   ...XXXXooooooXX...   ",
"   ..XXXXooooooooXX..   ",
"  ..XXXXoooXXXoooXXX..  ",
"  ..XXXXoooXXXoooXXX..  ",
" ..XXXXXXXXXXoooXXXXX.. ",
" ..XXXXXXXXooooXXXXXX.. ",
" ..XXXXXXXooooXXXXXXX.. ",
" ..XXXXXXoooXXXXXXXXX.. ",
" ..XXXXXoooXXXXXXXXXX.. ",
" ..XXXXXoooXXXXXXXXXX.. ",
"  ..XXXXXXXXXXXXXXXX... ",
"  ..XXXXXXXXXXXXXXXX..  ",
"   ..XXXoooXXXXXXXX...  ",
"   ...XXoooXXXXXXX...   ",
"    ...XXXXXXXXXX...    ",
"     ....XXXXXX....     ",
"       ...........      ",
"         .......        ",
"                        "};
}

set userPrefsIcon {
/* XPM */
static char * userPrefs_xpm[] = {
"24 24 5 1",
" 	c #B3B3B3B3B3B3",
".	c #B8B859590000",
"X	c #FFFFF8F8DCDC",
"o	c #B5B5AEAED1D1",
"O	c #E6E6A3A3A3A3",
"                        ",
"       ........ ..      ",
"      .............     ",
"     ..............     ",
"    ................    ",
"    ....XXXXXXXXX...    ",
"    ...XXXXXXXXXXX...   ",
"    ...XXXXXXXXXXX...   ",
"   ...XXooXXXXXooXX..   ",
"   ...XooooXXXooooX..   ",
"   ...XXooXXOXXooXX..   ",
"   ...XXXXXXOXXXXXX..   ",
"   ...XXXXXXOXXXXXX..   ",
"   ...XXXXXXXOXXXXX..   ",
"    .XXXXXXXXOXXXXXX    ",
"    XXXXXXXOOXXXXXXX    ",
"     XXXXXXXXXXXXXX     ",
"     XXXXXXXXXXXXXX     ",
"     XXXXOOXXOOXXXX     ",
"      XXXXOOOOXXXX      ",
"       XXXXXXXXXX       ",
"        XXXXXXXX        ",
"          XXXX          ",
"                        "};
}

set newIcon {/* XPM */
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 26 1",
"  c Gray0",
". c #151515",
"X c Gray30",
"o c Gray34",
"O c Gray35",
"+ c #646464",
"@ c #6d6d6d",
"# c Gray45",
"$ c #7c7c7c",
"% c #848484",
"& c Gray55",
"* c #939393",
"= c #9b9b9b",
"- c Gray64",
"; c #acacac",
": c #b4b4b4",
"> c #bcbcbc",
", c #c3c3c3",
"< c #cbcbcb",
"1 c Gray83",
"2 c gainsboro",
"3 c Gray89",
"4 c Gray92",
"5 c #f3f3f3",
"6 c Gray100",
"7 c None",
/* pixels */
"666666666666666666666666",
"66666666. ......... 6666",
"6666666 6 o+#$%*-;>.6666",
"666666 66 +@$%*-;>,.6666",
"66666 666 @$%*=;:,1.6666",
"6666.6666 #%&=;:,<2.6666",
"6666.     %&=-:><23.6666",
"6666.XO+#$%=-:><134.6666",
"6666.o+@$%*-:>,1346.6666",
"6666.+@$%*-;>,12456.6666",
"6666.@$%*=;:,124566.6666",
"6666.#%&=;:,<245666.6666",
"6666.%&=-:><2356666.6666",
"6666.&=-:><13466666.6666",
"6666.*-;><134666666.6666",
"6666.=;>,1245666666.6666",
"6666.;:,12456666666.6666",
"6666.:,<23566666666.6666",
"6666.,<134666666666.6666",
"6666.<1346666666666.6666",
"6666.13466666666666.6666",
"6666.24666666666666.6666",
"6666 .............. 6666",
"666666666666666666666666"
};
}


set newProjIcon {
/* XPM */
static char *magick[] = {
/* columns rows colors chars-per-pixel */
"24 24 26 1",
"  c Gray0",
". c #151515",
"X c Gray30",
"o c Gray34",
"O c Gray35",
"+ c #646464",
"@ c #6d6d6d",
"# c #727272",
"$ c #7b7b7b",
"% c #848484",
"& c Gray55",
"* c Gray58",
"= c #9b9b9b",
"- c #a2a2a2",
"; c Gray68",
": c #b6b6b6",
"> c #bbbbbb",
", c #c3c3c3",
"< c Gray80",
"1 c Gray83",
"2 c gainsboro",
"3 c Gray89",
"4 c Gray93",
"5 c Gray94",
"6 c Gray100",
"7 c None",
/* pixels */
"666666666666666666666666",
"66666666. ......... 6666",
"6666666 6 o+#$%*-;>.6666",
"666666 66 +@$%*-;>,.6666",
"66666 666 @$%*=;:,1.6666",
"6666.666          2.6666",
"6666.    66666666 3.6666",
"6666.XO+ 66666666 4.6666",
"6666.o+@ 66666666 6.6666",
"6666.+@$ 66666666 6.6666",
"6666.@$% 66666666 6.6666",
"6666.#%* 66666666 6.6666",
"6666.%&= 66666666 6.6666",
"6666.&*- 66666666 6.6666",
"6666.*-; 66666666 6.6666",
"6666.=;> 66666666 6.6666",
"6666.;:, 66666666 6.6666",
"6666.:,< 66666666 6.6666",
"6666.><1 66666666 6.6666",
"6666.<13 66666666 6.6666",
"6666.134          6.6666",
"6666.24566666666666.6666",
"6666 .............. 6666",
"666666666666666666666666"
};
}

set reloadIcon {
/* XPM */
static char * reload_xpm[] = {
"24 24 2 1",
" 	c grey98",
".	c #28A2AAAA1861",
"                        ",
"                        ",
"    .......             ",
"     ...... ...         ",
"      .....  ....       ",
"     ......    ...      ",
"    .......     ...     ",
"    .......      ...    ",
"   ..... ..      ...    ",
"   ....   .       ...   ",
"   ...            ...   ",
"   ...            ...   ",
"   ...            ...   ",
"   ...            ...   ",
"   ...       .   ....   ",
"    ...      .. .....   ",
"    ...      .......    ",
"     ...     .......    ",
"      ...    ......     ",
"       ....  .....      ",
"         ... ......     ",
"             .......    ",
"                        ",
"                        "};
}
set jumpIcon {
/* XPM */
static char * jump2_xpm[] = {
"24 24 5 1",
"       c #FAFAFAFAFAFA",
".      c #000000000000",
"X      c #2828AAAA1818",
"o      c #F0F0A0A0FFFF",
"O      c #A0A0FFFFFFFF",
"          .           . ",
"         XXXX         . ",
"       XXXXXXXX       . ",
"      XXXXXXXXXXX     . ",
".....XXXXXXXXXXXXX......",
"ooooXXXXXXXXXXXXXXX   . ",
"ooooXXXXoo.   XXXXX   . ",
"oooXXXXooo.    XXXXX  . ",
"oooXXXoooo.     XXXX  . ",
"ooXXXXoooo.OOXXOXXXX XX ",
"  XXX     .OOOXXXXXXXX. ",
"  XXX     .OOOOXXXXXX . ",
"  XXX     .OOOOXXXXXX . ",
"..XX.......OOOOOXXXX....",
" XXX      .OOOOOXXXXoo. ",
" XXX      .OOOOOOXXooo. ",
" XXX      .OOOOOOoXooo. ",
" XX       .OOOOOOooooo. ",
" XX       .OOOOOOooooo. ",
" XX       .      ooooo. ",
" XX       .      ooooo. ",
" XX       .      ooooo. ",
"........................",
"          .           . "};
}
set goHomeIcon {
/* XPM */
static char * goHome_xpm[] = {
"24 24 2 1",
" 	c grey98",
".	c #28A2AAAA1861",
"                        ",
"                        ",
"                        ",
"                        ",
"         .....          ",
"       .........        ",
"      ...........       ",
"      ....   .....      ",
"     ....      ....     ",
"    ....        ...     ",
"    ...          ...    ",
" .. ... ..       ...    ",
"  .......         ..    ",
"   .....          ...   ",
"    ...            ..   ",
"    ...            ..   ",
"     .             ...  ",
"                    ..  ",
"                    ..  ",
"                    ..  ",
"                    ..  ",
"                    ..  ",
"                        ",
"                        "};
}


set printerIcon {
/* XPM */
static char * printer_xpm[] = {
"24 24 5 1",
" 	c grey98",
".	c #000000000000",
"X	c #AEBAB2CAAEBA",
"o	c #FFFFAEBA1861",
"O	c #618565956185",
"                        ",
"                        ",
"     ..............     ",
"     .            .     ",
"     . ... ...... .     ",
"     .            .     ",
"     . . .... .. ..     ",
"     .            .     ",
"     .  .. .. . . .     ",
"     .            .     ",
"     . ... .... . .     ",
"     .            .     ",
"     . .... ..... .     ",
"    ................    ",
"   .                .   ",
"  . XXXXXXXXXXXXoooX .  ",
"  .XXXXXXXXXXXXXoooXX.  ",
"  .XXXXXXXXXXXXXXXXXX.  ",
"  .XXXXXXXXXXXXXXXXXX.  ",
"  .OXXXXXXXXXXXXXXXXO.  ",
"   .OOOOOOOOOOOOOOOO.   ",
"    ................    ",
"                        ",
"                        "};
}


set vd_deleteDateIcon {
/* XPM */
static char * deleteDate_xpm[] = {
"24 24 6 1",
" 	c #F7DEF3CEF7DE",
".	c #000000000000",
"X	c #69A671C669A6",
"o	c #FFFF00000000",
"O	c #000096580000",
"+	c #FFFFF3CEA699",
"   .                 .  ",
"   .                 .  ",
"   .                 .  ",
"XXX.XXXXXXXXXXXXXXXXX.XX",
"  o.                 . o",
" ooo                 .oo",
"  ooooOOOOOOOOOOOOOOoooo",
"   .ooo+++++++++++oooo  ",
"   .Oooo+++++++++oooo.  ",
"XXX.O+oooo+++++oooo+O.XX",
"   .O+++ooo+++oooo++O.  ",
"   .O++++ooooooo++++O.  ",
"   .O++++++ooo++++++O.  ",
"   .O++++oooooo+++++O.  ",
"   .O++oooo++oooo+++O.  ",
"XXX.O+oooo+++++ooo++O.XX",
"   .oooo++++++++ooooO.  ",
"   oooo+++++++++++ooo.  ",
" ooooOOOOOOOOOOOOOOooo  ",
"ooo.                oooo",
"   .                 .oo",
"XXX.XXXXXXXXXXXXXXXXX.XX",
"   .                 .  ",
"   .                 .  "};
}
set vd_suspendDateIcon {
/* XPM */
static char * suspendDate_xpm[] = {
"24 24 6 1",
" 	c #F7DEF3CEF7DE",
".	c #000000000000",
"X	c #69A671C669A6",
"o	c #FFFF00000000",
"O	c #000096580000",
"+	c #FFFFF3CEA699",
" .       .       .      ",
" .       .       .      ",
" .       .       .      ",
"X.XXXXXXX.XXXXXXX.XXXXXX",
" o       .o      .      ",
"ooo      oo      .      ",
" ooOOOOOOoo      .OOOOOO",
" .oo++++oo       .O+++++",
" .ooo++ooo       .O+++++",
" .Ooo++oo.       .O+++++",
"X.O+ooooO.XXXXXXX.O+++++",
" .O+ooooO.       .O+++++",
" .O+ooo+O.       .O+++++",
" .O+ooooO.       .O+++++",
" .Ooo+ooO.       .O+++++",
" .ooo++oo.       .O+++++",
" .oo+++ooo       .O+++++",
"XooOOOOOooXXXXXXX.OOOOOO",
"ooo      oo      .      ",
" .       oo      .      ",
" .       .       .      ",
" .       .       .      ",
" .       .       .      ",
" .       .       .      "};
}
set vd_shiftDateIcon {
/* XPM */
static char * shiftDate_xpm[] = {
"24 24 9 1",
" 	c #F7DEF3CEF7DE",
".	c #000000000000",
"X	c #69A671C669A6",
"o	c #8617C30B8617",
"O	c #000096580000",
"+	c #FFFFFBEEC71B",
"@	c #FFFFF3CEA699",
"#	c #00000000FFFF",
"$	c #FFFFFFFFFFFF",
" .       .       .      ",
" .       .       .      ",
" .       .       .      ",
"X.ooooooo.XXXXXXX.OOOOOO",
" .o+++++o.       .O@@@@@",
" .o+++++o.       .O@@@@@",
" .o+++++o.       .O@@@@@",
" .o+++++o.       .O@@@@@",
" .o++##+o.       .O@@@@@",
" .o++###o.       .O@@@@@",
"X.o++####.XXXXXXX.O@@@@@",
" .o+++####       .O@@@@@",
" .ooooo####  #   .OOOOOO",
" .    $ ####O#OOO.      ",
" .     $$#####@@O.      ",
" .       .####@@O.      ",
" .       .O###@@O.      ",
"X.XXXXXXX#####@@O.XXXXXX",
" .       .O@@@@@O.      ",
" .       .O@@@@@O.      ",
" .       .O@@@@@O.      ",
" .       .O@@@@@O.      ",
" .       .OOOOOOO.      ",
" .       .       .      "};
}
set vd_modifyDateIcon {
/* XPM */
static char * changeDate_xpm[] = {
"24 24 4 1",
" 	c #F7DEF3CEF7DE",
".	c #00000000FFFF",
"X	c #E79DC30B8617",
"o	c #000000000000",
"                        ",
"                        ",
"                        ",
"                  .XX   ",
"                 ..XX   ",
"                .....   ",
"               .....    ",
"              .....     ",
"             .....      ",
"            .....       ",
"           .....        ",
"          .....         ",
"         .....          ",
"        .....           ",
"       .....            ",
"      X....             ",
"      X...              ",
"     XXXX               ",
"     oX                 ",
"    o                   ",
"                        ",
"                        ",
"                        ",
"                        "};
}
set vd_reminderOnIcon {
/* XPM */
static char * reminderOn_xpm[] = {
"24 24 3 1",
" 	c #F7DEF3CEF7DE",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
" ...................... ",
" ..XXXXXXXXXXXXXXXXXX.. ",
" .X..XXXXXXXXXXXXXX..X. ",
" .XXX.XXXXXXXXXXXX.XXX. ",
" .XXXX..XXXXXXXX..XXXX. ",
" .XXXXXX.XXXXXX.XXXXXX. ",
" .XXXXXXX..XX...XXXXXX. ",
" .XXXXX..XX..XXX..XXXX. ",
" .XXX..XXXXXXXXXXX.XXX. ",
" .X..XXXXXXXXXXXXXX..X. ",
" ..XXXXXXXXXXXXXXXXXX.. ",
" ...................... ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        ",
"                        "};
}
set vd_reminderOffIcon {
/* XPM */
static char * reminderOff_xpm[] = {
"24 24 4 1",
" 	c #F7DEF3CEF7DE",
".	c #FFFF00000000",
"X	c #000000000000",
"o	c #FFFFFFFFFFFF",
"                        ",
"                        ",
"    .            .      ",
"   ...          ..      ",
"    ...         ..      ",
"     ..        ..       ",
" XXXXX..XXXXXX...XXXXXX ",
" XXooo...oooo...oooooXX ",
" XoXXoo...ooo..ooooXXoX ",
" XoooXoo..oo..ooooXoooX ",
" XooooXXo.....ooXXooooX ",
" XooooooX....ooXooooooX ",
" XoooooooX...XXXooooooX ",
" XoooooXX....oooXXooooX ",
" XoooXXoo..o..ooooXoooX ",
" XoXXooo..oo...ooooXXoX ",
" XXoooo...ooo...oooooXX ",
" XXXXX...XXXXX..XXXXXXX ",
"      ..       ..       ",
"     ..        ...      ",
"    ...         ..      ",
"                        ",
"                        ",
"                        "};
}

    set groupListExclusiveIcon {
/* XPM */
static char * excl_xpm[] = {
"12 12 3 1",
"       c #9C9C9C9C9C9C",
".      c #FFFFF0F0E0E0",
"X      c #FFFFD4D45252",
"            ",
"    ....    ",
"   ......   ",
"  ...XX...  ",
"  ..XXXX..  ",
"  ..XXXX..  ",
"  ...XX...  ",
"   ......   ",
"    ....    ",
"    ....    ",
"    ....    ",
"    ....    "};
}


set groupListAllIcon {
/* XPM */
static char * all_xpm[] = {
"12 12 8 1",
"       c #9C9C9C9C9C9C",
".      c #D5D5C8C8BBBB",
"X      c #C7C700001212",
"o      c #00000000FFFF",
"O      c #F1F1E3E3D4D4",
"+      c #262680801313",
"@      c #B8B899993B3B",
"#      c #FFFFF0F0E0E0",
" ...   ...  ",
"..X.. ..o.. ",
".XXX. .ooo. ",
"..X.OOO.o.OO",
" ..OO+OO.OO@",
"   O+++O O@@",
" ###O+####O@",
"##@##O##o##O",
"#@@@# #ooo# ",
"##@## ##o## ",
" ###   ###  ",
"            "};
}
set groupListEmptyIcon {
/* XPM */
static char * all_xpm[] = {
"12 12 1 1",
"       c none",
"            ",
"            ",
"            ",
"            ",
"            ",
"            ",
"            ",
"            ",
"            ",
"            ",
"            ",
"            "};
}

set adrFolderIcon {
    /* XPM */
static char * folder2_xpm[] = {
"24 24 26 1",
"       c #FFFFFFFFFFFF",
".      c #71C679E771C6",
"X      c #79E7861779E7",
"o      c #71C67DF771C6",
"O      c #86178E388617",
"+      c #96589A699658",
"@      c #9E79A2899E79",
"#      c #86178A288617",
"$      c #8E3896588E38",
"%      c #A699A699A699",
"&      c #AEBAAEBAAEBA",
"*      c #000000000000",
"=      c #A699AEBAA699",
"-      c #AEBAB2CAAEBA",
";      c #BEFBBEFBBEFB",
":      c #69A671C669A6",
">      c #69A675D669A6",
",      c #79E7820779E7",
"<      c #A699AAAAA699",
"1      c #B6DABAEAB6DA",
"2      c #C71BC71BC71B",
"3      c #861786178617",
"4      c #8E3892488E38",
"5      c #9E799E799E79",
"6      c #B6DAB6DAB6DA",
"7      c #BEFBC30BBEFB",
"                        ",
"                        ",
"     .X                 ",
"    .oXO+@              ",
"    XX#$+%&             ",
"  **OO$+@=-;            ",
"  *::>o,<-12            ",
"  *::.o,3#O*            ",
"  *>..,X3#4$***         ",
"  *oo,,X#O4$+5@****     ",
"  *,,XX3#4$++5%<=-6**   ",
"  *X33##O4$+5@%=&-6;*   ",
"  *###O44$++@%<=&61;*   ",
"  *OO44$$++5@%=&-617*   ",
"  *$$$$+++5@%<=-61;7*   ",
"  *+++++5@@%<=&-6;72*   ",
"  *++555@%%<=&-61;22*   ",
"  **@@@%%<==&-61;722*   ",
"    ****==&--61;7222*   ",
"        ***661;72222*   ",
"           ****22222*   ",
"               ****2*   ",
"                   **   ",
"                        "};

}

set adrFilterIcon {
/* XPM */
static char * filter_xpm[] = {
"24 24 4 1",
" 	c #FFFFFFFFFFFF",
".	c #000000000000",
"X	c #0000CF3C0000",
"o	c #C71B00000000",
"                        ",
"                        ",
"                        ",
"                        ",
"       .                ",
"      ..  .       XXXX  ",
"       ....  .    XXXX  ",
"       .  ....  .  XXX  ",
"      ..  .  ....XXXXX  ",
"       ....  .  ..X  X  ",
"       .  ....XX.       ",
"      .. ooXX....       ",
"       .ooXXX.  ..      ",
"       ooXXXXo  .       ",
"      .oXXXooo...       ",
"    oooXXooo .  ..      ",
" oooooXXoo....  .       ",
"  oooXXooo.  ....       ",
"  ooXXooo    .  ..      ",
"   XXooo        .       ",
"   Xoooo                ",
"    ooo                 ",
"     oo                 ",
"                        "};
}


set selDateCalIcon {
/* XPM */
static char * cal_xpm[] = {
"16 16 5 1",
" 	c #000000000000",
".	c #717171717171",
"X	c #FFFFFFFFFFFF",
"o	c #00000000E3E3",
"O	c #E0E020202020",
"               .",
" X.X.o.X.X.O.O .",
" X.X.o.X.X.O.O .",
" ............. .",
" o.X.X.X.X.o.O .",
" o.X.X.X.X.o.O .",
" ............. .",
" X.o.X.o.X.O.O .",
" X.o.X.o.X.O.O .",
" ............. .",
" X.X.X.X.o.O.O .",
" X.X.X.X.o.O.O .",
" ............. .",
" X.X.o.X.X.O.O .",
" X.X.o.X.X.O.O .",
"               ."};
}

set jumpHomeIcon {
/* XPM */
static char * home2_xpm[] = {
"24 24 8 1",
"       c #FFFFFBEEFFFF",
".      c #FFFF00000000",
"X      c #FFFFDB6CBEFB",
"o      c #B6DA5D752081",
"O      c #186179E71040",
"+      c #FFFFFFFFFFFF",
"@      c #28A2AAAA1861",
"#      c #000000000000",
"                        ",
"         .              ",
"        ...             ",
"       .....            ",
"      .......           ",
"     .........          ",
"    ...........         ",
"   .............        ",
"  ...............       ",
" ..XXXXXXXXXXXXX..      ",
" . XXooooXooOOOOOOO     ",
"   XXo++oXoO@@@@@@@@@   ",
"   XX@++oOO@@@@@@@@@@@  ",
"   XX@@ooO@@ooXX    @@@ ",
"   XXX@@O@@XXXXX      @ ",
"   XXX@@@@o@@oXX        ",
"   XXo@@@@@@+oXX        ",
"   XXoo@@@o++oXX        ",
"   XXoo@#XooooXX        ",
"   XXooooXXXXXXX        ",
"   XXooooXXXXXXX        ",
"   XXooooXXXXXXX        ",
"                        ",
"                        "};
}

set intoClipBoardIcon {
/* XPM */
static char * clip2_xpm[] = {
"12 12 4 1",
"       c none",
".      c #000000000000",
"X      c #F8F8F0F0E8E8",
"o      c #2828AAAA1818",
"            ",
"   ........ ",
"   .X.XX.X. ",
"   .XX..XX. ",
"   ooooXXX. ",
" XoooooXoX. ",
"  ooXooooX. ",
" oo.XXoooX. ",
" oo.XooooX. ",
" o .XXXXXX. ",
"   ........ ",
"            "};
}

}
