#!/usr/bin/X11/tixwish
#  File: lang_de.tcl
# 
#      This file is part of minkowsky
# 
#      Copyright (C) 2001-2002 by Rdiger Goetz
#      Author: Rdiger Goetz <minkowsky@r-goetz.de>
# 
#      Time-stamp: <05-Jun-2002 22:18:14 goetz>
# 
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
# 
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
# 
#      You should have received a copy of the GNU General Public License
#      along with this program; if not, write to the Free Software
#      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#  
proc languageDE { } {
    global _buttonText _addrText _allgText _gselText _noteText _calText _prefText _projText  _ballonText
    global _reminderTransl _reminderTranslPart _helpText  _printText
    global weekDays weekDaysAbk monAbk monNames monlen progname longProgName
    global _dateOrder
    global dringlichStr depStr  TODOstatStr
    global partStatus partStatusStr

    global datePermRefStr datePermSym datePartType

    set datePermRefStr "ztkztkd"
    set datePermSym(rz) "z"
    set datePermSym(r) ""
    set datePermSym(rt) "t"
    set datePermSym(rk) "k"
    set datePermSym(wz) "z"
    set datePermSym(w) ""
    set datePermSym(wt) "t"
    set datePermSym(wk) "k"
    set datePermSym(dd) "d"

    set datePartType(I) "I"
    set datePartType(E) "E"
    set datePartType(T) "T"
    set datePartType(A) "A"
    set datePartType(i) "i"

    set _dateOrder "de"
    set progname "Minkowsky"
    set longProgName "Minkowsky Raum-Zeit-Verwaltung"

    set weekDays "Montag Dienstag Mittwoch Donnerstag Freitag Sonnabend Sonntag Montag Dienstag Mittwoch Donnerstag Freitag Sonnabend Sonntag"
    set weekDaysAbk "Mo Di Mi Do Fr Sa So"
    set monlen "0 31 28 31 30 31 30 31 31 30 31 30 31"
    set monAbk "??? Jan. Feb. Mrz Apr. Mai Juni Juli Aug. Sep. Okt. Nov. Dez."
    set monNames  "??? Januar Februar. Mrz April Mai Juni Juli August September Oktober November Dezember"

    #proj/Todo
    set dringlichStr "{sehr niedrig} niedrig verringert normal erhht hoch {sehr hoch} {am hchsten}"
    set TODOstatStr "erledigt neu offen abgesagt wartend angehalten {in Arbeit} berzogen"
    set depStr "{in Arbeit} berzogen erledigt gelscht angehalten {zu 'm' % erledigt} {Milestone 'm' erreicht'}"

    #claendar
    set partStatus "??? UKN OK NO OPEN PUSH"
    set partStatusStr "unbekannt unbekannt zugesagt abgesagt unsicher verschieben ???  ??? ??? ??? ??? ???"
#     set eddv_repTyp "off tag woche monat jeden alle wtag"
#     set eddv_repTypStr "off tglich wchentlich monatlich {jeden ...} {alle ...} {wochen-tglich}"
#     set eddv_repUnit "stunden tage woche monate jahre"

    set _buttonText(Cancel)             "Abbruch"
    set _buttonText(OK)                 "O.K."
    set _buttonText(Accept)             "Akzeptieren"
    set _buttonText(Apply)              "bernehmen"
    set _buttonText(Add)                "Hinzufgen"
    set _buttonText(Change)             "ndern"
    set _buttonText(Modify)             "ndern"
    set _buttonText(ApplyChange)        "nderung bernehmen"
    set _buttonText(Delete)             "Lschen"
    set _buttonText(Close)              "Schliessen"
    set _buttonText(no)                 "NEIN"
    set _buttonText(yes)                "ja"
    set _buttonText(noWide)             "   NEIN   "
    set _buttonText(yesWide)            "  ja  "
    set _buttonText(Create)             "Anlegen"
    set _buttonText(Show)               "Anzeigen"
    set _buttonText(Save)               "Speichern"
    set _buttonText(Replace)            "berschrieben"
    set _buttonText(Print)              "Drucken"
    set _buttonText(Help)               " Hilfe "
    set _buttonText(login)              " Login "

    set _allgText(specialThanks)        "Ein besonderes Danke auch an"


    set _allgText(dateThe)              "der"
    set _allgText(User)                 "User"  
    set _allgText(Users)                "ser"  
    set _allgText(Gruppe)               "Gruppe"
    set _allgText(GruppeAbk)            "Gr."
    set _allgText(Gruppen)              "Gruppen"
    set _allgText(Set)                  "Set"   
    set _allgText(Sets)                 "Sets"
    set _allgText(Raum)                 "Raum"
    set _allgText(Raume)                "Rume"
    set _allgText(Ort)                  "Ort"
    set _allgText(PageKal)              "  Kalender  "
    set _allgText(PageTodo)             "  Aufgaben und Projekte  "
    set _allgText(PageAdr)              "  Addressen  "
    set _allgText(Error)                "Fehler"
    set _allgText(ERROR)                "FEHLER"
    set _allgText(Fatal)                "Schwerer Fehler"
    set _allgText(FATAL)                "SCHWERER FEHLER"
    set _allgText(Warn)                 "Warnung"
    set _allgText(WARN)                 "WARNUNG"
    set _allgText(Attention)            "Achtung"
    set _allgText(ATTENTION)            "ACHTUNG"
    set _allgText(Reason)               "Grund"
    set _allgText(calSelection)         "Kalenderauswahl"
    set _allgText(taskSelection)        "Aufg.-Listen-Auswahl"
    set _allgText(AddrBook)             "Adressbuch"

    set _allgText(errorOnTransfer1)      "Der Minkowsky-Server meldet eine Fehler bei der\n Ausfhrung des Komamndos"
    set _allgText(errorOnTransfer2)      "Die Grund ist"

    set _allgText(wmTitle_pr)           "Drucken"
    set _allgText(Printer)              "Drucker"
    set _allgText(LabelPrint2File)      "in eine Datei drucken"
    set _allgText(LabelPrint2FileShow)  "in eine Datei drucken und anzeigen"
    set _allgText(Options)              "Optionen"
    set _allgText(PrintType)            "Formular"
    set _allgText(PrintPageFormat)      "Seitenformat"
    set _allgText(PrintLinesPerList)    "max. Zeilen pro Teilnehmerliste"
    set _allgText(PrintIgnoreInit)      "  Initaitor ignorieren"
    set _allgText(PrintIgnoreWeekEnd)   "  Wochenenden ignorieren"
    set _allgText(PrintCalWeekView)     "Wochebersicht"
    set _allgText(PrintCalMonthView)    "Monatbersicht"
    set _allgText(PrintCalListView)     "Liste"
    set _allgText(PrintCalCurView)      "aktuelle Ansicht"
    set _allgText(PrintCalVom)          "vom"
    set _allgText(PrintCalBis)          "bis"
    set _allgText(PrintCalUseColor)     "in Farbe"
    set _allgText(PrintCapWarn1)        "Die Druckereinstallung enthlt den Drucker"
    set _allgText(PrintCapWarn2)        "doppelt."
    set _allgText(PrintCapWarn3)        "wird den zweiten Eintrag ignorieren. Bitte weisen sie den Systemadministrator auf diese Problem hin"
    set _allgText(PrintToFileErrorTitle) "Fehler bei der Druckausgabe"
    set _allgText(PrintToFileError)     "Die Druckdatei kann nicht auf der angegebenen Datei ausgegeben werden."

    set _allgText(ServerDown1a)         "Der"
    set _allgText(ServerDown1b)         "-Server kann nicht erreicht werden.\nBitte melden sie dies ihrem Administrator und starten sie"
    set _allgText(ServerDown1c)         "spter neu."
    set _allgText(ServerDown2a)         "Der"
    set _allgText(ServerDown2b)         "versucht die Verbindung wieder herzustellen.\n"

    set _allgText(ServerBack-a)         "Die Verbindung zum"
    set _allgText(ServerBack-b)         "-Server\nkonnte wieder aufgenommen werden\nDie letzte Aktion muss aber wiederholt werden."

    set _allgText(wmTitle_log)          "Login to"
    set _allgText(loginUserName)        "Benutzername"
    set _allgText(loginPassword)        "Passwort" 
    set _allgText(loginMeterStart)      "starte"
    set _allgText(loginMeterConnect)    "Verbinde zum Server"
    set _allgText(loginMeterPref)       "lese Benutzer Daten"
    set _allgText(loginMeterLists)      "Hole Benutzer Listen"
    set _allgText(loginMeterCal)        "Erzeuge Kalender"
    set _allgText(loginMeterAdr)        "Erzeuge Addressbuch" 
    set _allgText(loginMeterProj1)      "Hole Project Listen"
    set _allgText(loginMeterProj2)      "Erzeuge Projectansicht"
    set _allgText(loginMeterDone)       "Fertig"

    set _allgText(wmTitelAbout)         "ber"
    set _allgText(AboutMinkoFunc)       "Raum/Zeit-Verwaltung"
    set _allgText(AboutVon)             "von"
    set _allgText(AboutVersion)         "Version"
    set _allgText(AboutVom)             "vom"

    set _allgText(Perms)                "Rechte"
    set _allgText(permRead)             "Lesen"
    set _allgText(permModi)             "ndern"
    set _allgText(permDelete)           "Lschen"

    set _allgText(dateSep)              "."


    set _allgText(ErrorNoHelpTitle)     "Fehler: Keine Online-Hilfe"
    set _allgText(ErrorNoHelpText)      "Es konnte keine Online-Hilfe gefunden werden"

    set _gselText(wmTitel_ssd)          "Name des Sets"
    set _gselText(wmTitle_css)          "Set existiert schon"
    set _gselText(SetExisting1)         "Es existiert bereits ein Set mit dem Namen "
    set _gselText(SetExisting2)         "Soll dieses Set berschrieben werden ? "
    set _gselText(ButSaveSet)           "Set speichern"

    set _addrText(ButtonFilter)         "Filter"
    set _addrText(ButtonClearFilter)    "Filter zurcksetzen"
    set _addrText(AssignFolder)         "Einem Ordner zuweisen"
    set _addrText(ApplyChange)          "Addresse bernehmen"
    set _addrText(wmTitel_adf)          "Definiere Address Filter"
    set _addrText(wmTitel_naf)          "Neuen Address-Ordner"
    set _addrText(wmTitel_adv)          "Adressse"
    set _addrText(wmTitel_afv)          "Address Ordner"
    set _addrText(wmTitel_adl)          "Address einem Ordner zuweisen"
    set _addrText(newAddressName)       "neue Addresse"
    set _addrText(delAdr1)              "Wollen sie die Addresse von"
    set _addrText(delAdr2)              "wirklich lschen ?"
    set _addrText(delAdrSort)           "1O2"
    set _addrText(delFolder1)           "Wollen sie den Addresse-Ordner"
    set _addrText(delFolder2)           "wirklich lschen ?"
    set _addrText(delFolderSort)        "1O2"
    set _addrText(Folder)               "Ordner"
    set _addrText(WarnFolderStructDamage) "Warnung: Teile der Ordnerstruktur des Addressbuches\n sind beschdigt (z.B. durch einen Ringschluss)\nDaher wurden alle Ordner des beschdigten Teils \nder Ornderstruktur ins Wurzelverzeichnis
verschoben.\n Bitte sortieren sie die Ordner wieder an ihren korrekte Platz.\n"

    set _addrText(PageAddress)          " Addressen "
    set _addrText(PageCommu)            " Fon & Net" 
    set _addrText(PageBank)             " Bank "
    set _addrText(PageMisc)             " Misc "
    set _addrText(PagePrivate)          " Privat "
    set _addrText(private)              "privat"
    set _addrText(priv)                 "priv."
    set _addrText(Name)                 "Name"
    set _addrText(Company)              "Firma"
    set _addrText(ShortCompanyName)     "Firmenname (Kurzform)"
    set _addrText(ShortForm)            "Kurzform"
    set _addrText(Position)             "Position"
    set _addrText(AdrAccess)            "Zugriffsrechte auf diese Addresse"
    set _addrText(AccessAll)            "voller Zugriff:"
    set _addrText(AccessNotes)          "Lesen & Notizen anlegen:"
    set _addrText(AccessRO)             "nur Lesen:"
    set _addrText(AccessDialogTitle)    "ndere Zugriffsrechte"
    set _addrText(LabelAllg)            "Allgemein"
    set _addrText(All)                  "Alle"
    set _addrText(Adr)                  "Addresse"
    set _addrText(Adr1)                 "Addresse 1"
    set _addrText(Adr2)                 "Addresse 2"
    set _addrText(PLZort)               "PLZ/Ort"
    set _addrText(Staat)                "Staat"
    set _addrText(Telefon)              "Telefon"
    set _addrText(Telefone)             "Telefone"
    set _addrText(mail)                 "e-Mail"
    set _addrText(mails)                "e-Mails"
    set _addrText(Handy)                "Handy"
    set _addrText(FAX)                  "FAX"
    set _addrText(Internet)             "Internet"
    set _addrText(WWW)                  "Web-URL"
    set _addrText(BankKonto)            "Bank Konto"
    set _addrText(Konto1)               "Konto 1"
    set _addrText(Konto2)               "Konto 2"
    set _addrText(KontoInh)             "Konotinhaber :"
    set _addrText(KontoNum)             "Konotnummer  :"
    set _addrText(Bank)                 "Bank         :"
    set _addrText(BLZ)                  "Bankleitzahl :"
    set _addrText(SteurNum)             "Steuernummer :"
    set _addrText(SteurNumm)            "Steuernummer"
    set _addrText(Descr)                "Beschreibung"
    set _addrText(ShortDescr)           "kurze Beschreibung"
    set _addrText(detailed)             "ausfhrlich"
    set _addrText(infos)                "weitere Infos"
    set _addrText(createAt)             "erstellt am "
    set _addrText(by)                   " durch "
    set _addrText(modifiedAt)           "gendert am "
    set _addrText(Birthday)             "Geburtstag "
    
    set _addrText(NewAdrFolder)         "Neuen Address Ordner anlegen"
    set _addrText(NameOfFolder)         "Name des Ordner: "
    set _addrText(changeableBy)         "darf gendert werden durch : "
    set _addrText(defOpen)              "ist standardmig geffnet"

    set _addrText(PrintTelefonList)     "Telefonliste"
    set _addrText(PrintAdresssList)     "Adressliste"
    set _addrText(PrintprivAddrList)    "private Adressliste"
    set _addrText(PrintFullList)        "vollstndige Liste"
    set _addrText(PrintCustomList)      "variable Liste"
    set _addrText(PrintFormat)          "Format"
    set _addrText(PrintAddrSel)         "Adressauswahl" 
    set _addrText(PrintCurrent)         "akutelle Liste"
    set _addrText(PrintAll)             "alle Addressen"
    set _addrText(PrintSeclected)       "angewhlte Addressen"
		  

    set _noteText(Note)                 "Gesprchsnotizen"
    set _noteText(NoteGenricNewTitle)   "neue Notiz"
    set _noteText(NoteNewTitle)         "berschrift der neuen Notiz:"
    set _noteText(wmTitel_ntd)          "Neue Notiz"
    set _noteText(wmTitel_npr)          "Notiz Drucken"
    set _noteText(wmTitel_snm)          "Verschicke die Notiz"
    set _noteText(NoteMailError1)       "Notiz konnte am Server nicht gendert werden\nGrund: "   
    set _noteText(NoteMailError1)       "Daher wuird keine e-mail verschickt"   
    set _noteText(NoteSendMail)         "Verschicke die Notiz   "
    set _noteText(NoteSendMailTo)       "an:"
    set _noteText(NoteButtonSendMail)   "Schicke Mail"
    set _noteText(NotePrintTextTitle)   "Gesprchsnotiz zur Addresse"
    set _noteText(NotePrintTextCreator) "Angelegt von"
    set _noteText(NotePrintTextAm)      "am"
    set _noteText(NotePrintTextUm)      "um"


#     set _calText(JumpTo)                "Springe nach"
#     set _calText(ButJump)               "Sprung"
    # wochenview.tcl
    set _calText(NaviTitle)             "Kalender-Navigation"
    set _calText(CalOfUser)             "Kalender von"
    set _calText(CalOfGroup)            "Kalender der"  
    set _calText(CalOfSets)             "Kalender des angewhlten Sets"
    set _calText(delDate1)              "Wollen sie den Termin" 
    set _calText(delDate2)              "wirklich lschen ?"
    #viewDate.tcl
    set _calText(private4Group)         "gruppenintern"
    set _calText(private)               "privat"
    set _calText(Zeit)                  "Zeit"
    set _calText(HiddenTitle)           "versteckter Titel"
    set _calText(von)                   "von"
    set _calText(bis)                   "bis"
    set _calText(bis2)                  "bis"
    set _calText(Details)               "Details"
    set _calText(Teilnehmer)            "Teilnehmer"
    set _calText(Status)                "Status"
    set _calText(Termin)                "Termin"
    set _calText(suspendDate1)          "Wollen sie den Termin" 
    set _calText(suspendDate2)          "wirklich aussetzen ?"
    set _calText(am)                    "am"
    set _calText(um)                    "um"
    set _calText(Heute)                 "Heute"
    set _calText(sendAnn)               "Mitteilung verschicken an"
    set _calText(partAll)               "Alle"
    set _calText(partInternal)          "Interne"
    set _calText(partExternal)          "Externe"
    set _calText(partNoone)             "niemand"
    set _calText(shiftDateTime)         "Termin verschieben auf ..."
    set _calText(shiftDateRoom)         "Termin verlegen nach ..."
    set _calText(Beginn)                "Beginn"
    set _calText(Ende)                  "Ende"  
    set _calText(shiftDateDetails)      "Details zur Verlegung"
    set _calText(butShift)              "Verlegen"
    set _calText(wmTitelShiftDate1)     "Termin"
    set _calText(wmTitelShiftDate2)     "verlegen"
    #add.tcl
    set _calText(Titel)                 "Titel"
    set _calText(AddPageTimes)          "Zeiten, Orte, etc."
    set _calText(AddPagePart)           "Teilnehmer"
    set _calText(AddPageDetails)        "Details und Kommentar"
    set _calText(AddSecTimesPlace)      "Ort in Raum und Zeit"
    set _calText(TerminOhneUhrzeit)     "Termin ohne Uhrzeit"
    set _calText(schwebenderTermin)     "schwebender Termin"
    set _calText(addRest)               "weitere Eigenschaften"
    set _calText(addGroupOfDate)        "zustndige Gruppe"
    set _calText(addPrivatStatus)       "Privat-Status"
    set _calText(addPriority)           "Prioritt"
    set _calText(addPriorityLow)        "niedrig"
    set _calText(addPriorityHigh)       "hoch"
    set _calText(addRepeat)             "Wiederholungen"
    set _calText(addRepeatDate)         "Termin regelmig wiederholen"
    set _calText(addRepeatInterVall)    "Intervall "
    set _calText(addRepeatDay)          "tglich"
    set _calText(addRepeatWorkingDay)   "wochen-tglich"
    set _calText(addRepeatWeek)         "wchentlich"
    set _calText(addRepeatMonth)        "monatlich"
    set _calText(addRepeatEvery1)       "jeden x.. des Monats"
    set _calText(addRepeatEvery2)       "alle"
    set _calText(addRepeatExcept)       "ausser"
    set _calText(addRepeatTimes)        "Hufigkeit"
    set _calText(addRepeatUnlimit)      "unbegrenzt"
    set _calText(addRepeatEveryText)    "Wiederholung alle "
    set _calText(addRepeatEveryHours)   "Stunden"
    set _calText(addRepeatEveryDays)    "Tage"
    set _calText(addRepeatEveryWeeks)   "Wochen"
    set _calText(addRepeatEveryMonth)   "Monate"
    set _calText(addRepeatEveryYears)   "Jahre"
    set _calText(addRemind)             "Erinnerungen"   
    set _calText(addRemindSend)         "Schicke"
    set _calText(addRemindInvite)       "Einladung"
    set _calText(addRemindRemind)       "Erinnerung"
    set _calText(addRemindDays)         "Tage"
    set _calText(addRemindHours)        "Stunden"
    set _calText(addRemindMin)          "Minuten"
    set _calText(addRemindBeforeBy)     "vorher als"
    set _calText(addRemindBefore)       "vorher"
    set _calText(addRemindVia)          "via"
    set _calText(addRemindByMail)       "E-mail"
    set _calText(addRemindByDialog)     "Fenster"
    set _calText(addRemindTo)           "an"
    set _calText(addRemindAdd)          "hinzufgen"

    set _reminderTransl(Minuten)            "Minuten"
    set _reminderTransl(Stunden)            "Stunden"
    set _reminderTransl(Tage)               "Tage"
    set _reminderTransl(E-mail)             "E-mail"
    set _reminderTransl(Fenster)            "Fenster"
    set _reminderTransl(Signal)             "Signal"
    set _reminderTranslPart(alle)               "alle"
    set _reminderTranslPart(Alle)               "Alle"
    set _reminderTranslPart(intern)             "intern"
    set tag "interne Teilnehmer"
    set _reminderTranslPart($tag) "interne Teilnehmer"
    set _reminderTranslPart(extern)             "extern"
    set tag "externe Teilnehmer"
    set _reminderTranslPart($tag) "externe Teilnehmer"

#Teilnehmer / Liste
    set _calText(addPartListName)       "Name"
    set _calText(addPartListStatus)     "Status"
    set _calText(addPartListPerms)      "Rechte"
    set _calText(addPartPopupType)      "Typ"

#Teilnehmer / 
    set _calText(addPartWmPerm)         "ndere Rechte fr"

#Teilnehmer / Auswahllist
    set _calText(addPartUserGroups)     "User / Groups"
    set _calText(addPartExternalPart)   "externe Teilnehmer"
    set _calText(addPartdefPermissions) "Standardrechte"
    set _calText(addPartAsInvitor)      "Einladener"
    set _calText(addPartAsPart)         "Teilnehmer"
    set _calText(addPartInfoOnly)       "Information"
    
#teilnehmer / Rechte 
    set _calText(permCoords)            "Zeiten & Orte"
    set _calText(permTexts)             "berschrift"
    set _calText(permParts)             "Teilnehmer"
    set _calText(permComments)          "Kommentar"
    set _calText(permDelete)            "Termin lschen"
    set _calText(typeInit)              "Initiator"
    set _calText(typeInvite)            "Einladener"
    set _calText(typePart)              "Teilnehmer"
    set _calText(typeExtern)            "Externe"
    set _calText(typeInfo)              "Informierter"
    set _calText(typeInfoShort)         "Inform."
#details
    set _calText(addDetails)            "Details"
    set _calText(addNewComments)        "neuer Kommentar"
    set _calText(addAddNewComment)      "neuen Kommentar hinzufgen"
    set _calText(addComments)           "Kommentare"
#buttons
    set _calText(addAddDate)            "Termin hinzufgen"
    set _calText(addModifyDate)         "Termin ndern"
    set _calText(addTypeNew)            "Termin hinzufgen"
    set _calText(addTypeModify)         "Termin ndern"
    set _calText(addDefaultTitle)       "Neuer Termine"

    set _calText(ErrorCantDelete)       "Termin kann nicht gelscht werden"
    set _calText(FullDay)               "ganztgig"

#printing Texts
    set _printText(MeterTitle)          "Drucken"
    set _printText(MeterPrepare)        "Bereite Ausdruck vor"
    set _printText(MeterGetData)        "Hole Daten"
    set _printText(MeterCreate)         "Erstelle Ausdruck"
    set _printText(Meter2Printer)       "Sende Daten zum Drucker"
    set _printText(Page)                "Seite"
    set _printText(CalWeek1)            "Wochenkalender von"
    set _printText(CalWeek2)            ""
    set _printText(CalFrom)             "von"
    set _printText(CalTo)               "bis"
    set _printText(CalMonth1)           "Monatskalender fr"
    set _printText(CalMonth2)           "von"
    set _printText(CalAppPrivate)       "privater Termin"
    set _printText(CalAppGroupOnly)     "gruppeninterner Termin"
    set _printText(CalList)             "Kalender"
    set _printText(CalListFrom)         "von"
    set _printText(CalListTo)           "bis"
    set _printText(CalListOf)           "fr"
    set _printText(AdrListTitleEntry)   "Listenberschrift"
    set _printText(ProjTitle)           "Aufgaben und projekte"
    set _printText(ProjTitleOf)         "von"
    set _printText(ProjFormat)          "Auswahl"
    set _printText(ProjFmtAll)          "Alle"
    set _printText(ProjFmtProjOpen)     "Nur Projekte (mit Aufgaben)"
    set _printText(ProjFmtProjClose)    "Nur Projekte (ohne Aufgaben)"
    set _printText(ProjFmtFreeTask)     "Nur Aufgaben ausserhalb von Projekten"
    set _printText(ProjFmtAllTask)      "Nur Aufgaben (auch in Projekten)"
    set _printText(ProjSplit)           "Splitte Projekte nur wenn es unvermeidlich ist"
    set _printText(ProjMore)            "weitere Aufgaben und Projekte auf der nchsten Seite"


#Aufgaben Projekte
#main
    set _projText(mainStatus)           "Status"
    set _projText(mainName)             "Aufgabe/Projekt"
    set _projText(mainStart)            "Beginn"
    set _projText(mainEnd)              "Zieltermin"
    set _projText(mainProgress)         "Fortschritt"
    set _projText(mainWorker)           "Bearbeiter"
    set _projText(mainInit)             "Initiator"
    set _projText(mainDring)            "D"

    set _projText(Legend)               "Legende"
    set _projText(LegendStati)          "Stati"
    set _projText(LegendNew)            "neue Aufgabe"
    set _projText(LegendDone)           "Aufgabe  erledigt"
    set _projText(LegendOpen)           "Aufgabe offen"
    set _projText(LegendCanceled)       "Aufgabe zurckgenommen"
    set _projText(LegendPending)        "Aufgabe im Wartezustand"
    set _projText(LegendSuspended)      "Aufgabe zurckgestellt"
    set _projText(LegendWIP)            "Aufgabe in Arbeit"
    set _projText(LegendDelayed)        "Aufgabetermin berzogen"
    set _projText(LegendUrgency)        "Dringlichkeiten"

    set _projText(projTitel)            "Titel"
    set _projText(projDescr)            "Beschreibung"
    set _projText(projWorker)           "Bearbeiter"
    set _projText(projwmViewTitle)      "Projekt"
    set _projText(projDel1)             "Wollen sie das Projekt"
    set _projText(projDel2)             "wirklich lschen?"
    set _projText(projFinishDate)       "Zieltermin"
    set _projText(projPrivate)          "privates Projekt"
    set _projText(projOperator)         "Bearbeiter"
    set _projText(projTaskList)         "Aufgabenliste"
    set _projText(projWmTitle)          "Bearbeite Projekt"
    set _projText(projnewTask)          "neue Aufgabe"
    set _projText(projChgPermWmTitle)   "Bearbeite Zugriffsrechte"
    set _projText(projPermText1)        "Rechte des"
    set _projText(projPermText2)        "an diesem Project"
    set _projText(projWritePerm)        "Schreibrechte fr dieses Prokjekt"
    set _projText(projDeletePerm)       "Lscherlaubnis fr dieses Projekt"
    set _projText(projDependWmTitle)    "Aufgabenabhngigkeit definieren"
    set _projText(projDependText1)      "Die Aufgabe"
    set _projText(projDependText2)      "wird aktiv, wenn die Aufgabe"
    set _projText(projDependText3)      ""
    set _projText(projDependText4)      " ist.  m="
 
    set _projText(todo)                 "Aufgabe"
    set _projText(todoTitel)            "Titel"
    set _projText(todoStatus)           "Status"
    set _projText(todoTaskDone1)        "Aufgabe zu"
    set _projText(todoTaskDone2)        "fertiggestellt"
    set _projText(todoPriority)         "Prioritt"
    set _projText(todoDescr)            "Beschreibung"
    set _projText(todoMilestones)       "Milestones"
    set _projText(todoWmTitle)          "Aufgabe"
    set _projText(todoDel1)             "Wollen sie die Aufgabe"
    set _projText(todoDel2)             "wirklich lschen?"
    set _projText(todoDefaultTitle)     "Neue Aufgabe"
    set _projText(todoTypeModify)       "Aufgabe ndern"
    set _projText(todoTypeNew)          "Neue Aufgabe"
    set _projText(totoModiPageCoords)   "Zeiten und Stati"
    set _projText(totoModiPageDescr)    "Beschreibung"
    set _projText(totoModiPageWorker)   "Bearbeiter"
    set _projText(totoModiPageReminder) "Mahner"
    set _projText(totoModiPageMilest)   "Milesstones"
    set _projText(todoModiTimesHeader)  "Aufgabe zu erledigen"
    set _projText(todoModiTimesFrom)    "von"
    set _projText(todoModiTimesTo)      "bis"
    set _projText(todoModiCurStatus)    "aktueller Status"
    set _projText(todoModiComplete)     "Grad der Fertigstellung"
    set _projText(todoModiUrgency)      "Dringlichkeit"
    set _projText(todoModiUrgencyDyn)   "dynamisch"
    set _projText(todoModiGroupAssign1) "Die Aufgabe ist der Gruppe"
    set _projText(todoModiGroupAssign2) "zugeordnet"
    set _projText(todoModiPublic)       "Allgemeinheit"
    set _projText(todoModiPrivate)      "private Aufgabe"
    set _projText(todoLoadText1)        "Belastung des Mitarbeiters"
    set _projText(todoLoadText2)        "durch diese Aufgabe"
    set _projText(todoWritePerm)        "Schreibrechte fr diese Aufgabe"
    set _projText(todoDeletePerm)       "Lscherlaubnis fr diese Aufgabe"
    set _projText(todoRemind)           "Erinnerungen"   
    set _projText(todoRemindSend)       "Schicke"
    set _projText(todoRemindWarning)    "Mahnung"
    set _projText(todoRemindRemind)     "Erinnerung"
    set _projText(todoRemindDays)       "Tage"
    set _projText(todoRemindHours)      "Stunden"
    set _projText(todoRemindMin)        "Minuten"
    set _projText(todoRemindBefore)     "vorher"
    set _projText(todoRemindAfter)      "nachher"
    set _projText(todoRemind_A)         "eine"
    set _projText(todoRemindBy)         "as"
    set _projText(todoRemindByMail)     "E-mail"
    set _projText(todoRemindByDialog)   "Fenster"
    set _projText(todoRemindTo)         "an"
    set _projText(todoRemindAdd)        "hinzufgen"
    set _projText(todoReminderAll)      "Alle"
    set _projText(todoMilesDone)        "fertig"
    set _projText(todoMilesName)        "Name des Milestones"
    set _projText(todoMilesComplete)    "equivalentes Fertigstellungsniveau"
    set _projText(todoPrintDring)       "Dringlichkeit"

    #project edit
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    set _projText(Legend2)              ""
    
   

    set _projText(Legend2)              ""

#pref panel
    set _prefText(PageRights)           "Rechte"
    set _prefText(PageCalRights)        "Kalender"
    set _prefText(PageDateRights)       "Termine"
    set _prefText(PageSecurity)         "Sicherheit"
    set _prefText(PagePwdSecurity)      "Passwort"
    set _prefText(PageLayout)           "Layout"
    set _prefText(PageCalLayout)        "Kalender"
    set _prefText(PageRemLayout)        "Erinnerer"
    set _prefText(PageBrwLayout)        "Browser"
    set _prefText(Wmtitle)              "Benutzer Voreinstellungen"
    set _prefText(panelTitle)           "Konfigurations Gruppen"
    set _prefText(descrPerm)            "Mit Kontrollfeldern knnen die Zugriffsrechhte Drritter auf den eigenen Kalender geregelt werden und die Standardrecht von Teilnehmern bei neu erzugeten Terminen festgelegt werden."
    set _prefText(descrLayout)          "In diesen Kontrollfelder werden diverse Layoutoptionen festgelegt"
    set _prefText(descrSecurity)        "In diesen Kontrollfelder werden Sicherheistrelevante Einstellungen vorgenommen"
    set _prefText(calPermGroup)         "Gruppen mit Sonderrechten"
    set _prefText(calLayoutOptions)     "Anzeigeoptionen"
    set _prefText(calLayoutIgnored)     "Anzeige von ignorierten Termin"
    set _prefText(calLayoutInformed)    "Anzeige von Informations-Termin"
    set _prefText(calLayoutToolTipps)   "Anzeige von ToolTips"
    set _prefText(calLayoutMainTime)    "Kernzeit"
    set _prefText(calLayoutFrom)        "von"
    set _prefText(calLayoutTo)          "bis"
    set _prefText(calLayout_oClock)     "Uhr"
    set _prefText(calLayoutLines)       "Zahl der \"Zeilen\" fr Termine ohne Uhrzeit"
    set _prefText(calLayoutLines4Day)   "im Tageskalender"
    set _prefText(calLayoutLines4Week)  "im Wochenkalender"
    set _prefText(calLayoutLines4Month) "im Monatskalender"
    set _prefText(calLayoutLines4Group) "im Gruppenkalender"
    set _prefText(reminderSignal)       "Erinnerungs-Signal"
    set _prefText(reminderSignalBeep)   "Beep"
    set _prefText(reminderSignalCmd)    "Kommando"
    set _prefText(reminderType)           "Typ"
    set _prefText(reminderTypeDateInvite) "Termin  -Einladungen"
    set _prefText(reminderTypeDateRemind) "Termin  -Erinnerungen"
    set _prefText(reminderTypeTaskRemind) "Aufgaben-Erinnerungen"
    set _prefText(reminderTypeTaskDelay)  "Aufgaben-Mahnungen"
    set _prefText(reminderalwaysAs)       "immer als"
    set _prefText(reminderalwaysLike)     "immer wie"
    set _prefText(reminderalwaysIn)       "immer im"
    set _prefText(reminderalwaysMail)     "Mail"
    set _prefText(reminderalwaysDate)     "im Termin"
    set _prefText(reminderalwaysDialog)   "Dialog" 
    set _prefText(securityPassword)     "Passwort"
    set _prefText(securityPasswordRep)  "Wiederholung"
    set _prefText(ErrorPwd)             "Die Passwrter stimmen nicht berein"
    set _prefText(browserSelection)     "Auswahl der Hilfstextbrowsers"
    set _prefText(browserOwn)           "anderer :"


    #Ballonhelp Toolbar
    set  _ballonText(MainExit)              "Beende"
    set  _ballonText(MainHome)              "Zurck zum Ausgangspunkt"
    set  _ballonText(MainPrefs)             "Benutzereinstellungen"
    set  _ballonText(MainHelp)              "Online Hilfe"
    set  _ballonText(MainAbout)             "ber"
    set  _ballonText(MainCalPrint)          "Kalender drucken"
    set  _ballonText(MainCalReload)         "Kalender vom Server neuladen"
    set  _ballonText(MainCalNew)            "Neuen Termin anlegen"
    set  _ballonText(MainCalDay)            "Tageskalender"
    set  _ballonText(MainCalWeek)           "Wochenkalender"
    set  _ballonText(MainCalMonth)          "Monatskalender"
    set  _ballonText(MainCalToday)          "Kalender von heute"
    set  _ballonText(MainCalNavigator)      "Kalender Navigation"
    set  _ballonText(MainCalSwitchIgnore)   "ignorierte Termine\n(un)sichtbar machen"
    set  _ballonText(MainCalSwitchInfo)     "Informations-Termine\n(un)sichtbar machen"
    set  _ballonText(MainCalSwitchGroup)    "Gruppenkalender als Einzel-\noder Gesamtkalender"
    set  _ballonText(MainProjPrint)         "Aufgabenliste drucken"
    set  _ballonText(MainProjReload)        "Aufgabenliste vom\nServer neuladen"
    set  _ballonText(MainProjNew)           "Neue Aufgabe"
    set  _ballonText(MainProjNewProj)       "Neues Projekt"
    set  _ballonText(MainAdrPrint)          "Addressbuch drucken"
    set  _ballonText(MainAdrReload)         "Addressbuch vom\nServer neuladen"
    set  _ballonText(MainAdrNew)            "neue Addresse"
    set  _ballonText(MainAdrNewFolder)      "neuer Addressordner"
    set  _ballonText(MainAdrFilter)         "Addressen filtern"

    set _ballonText(GS_TitelCal)            "Auswahl, der Kalender, die angezeigt werden sollen"
    set _ballonText(GS_TitelProj)           "Auswahl, der Aufgabenlisten, die angezeigt werden sollen"
    set _ballonText(GS_excl)                "Diesen Nutzer alleine auswhlen"
    set _ballonText(GS_GroupAll)            "Alle Mitglieder dieser Gruppe auswhlen"
    set _ballonText(GS_SetAll)              "Alle Mitglieder dieses Sets auswhlen"
    set _ballonText(GS_Show)                "aktuelle Auswahl anzeigen"
    set _ballonText(GS_SaveSet)             "aktuelle Auswahl als Set speichern"

    set _ballonText(viewDate_Ignore)        "Diesen Termin (nicht mehr) ignorieren"
    set _ballonText(viewDate_noReminder)    "Erinnerungen (nicht mehr) unterdrcken"
    set _ballonText(viewDate_Delete)        "Diesen Termin lschen"
    set _ballonText(viewDate_DeleteRepAll)  "Diesen regelmssigen Termin ganz lschen"
    set _ballonText(viewDate_Susepend)      "Diesen regelmssigen Termin aussetzen,\nd.h. an dieser Stelle lschen"
    set _ballonText(viewDate_Modify)        "Diesen Termin bearbeiten"
    set _ballonText(viewDate_Shift)         "Diesen regelmssigen Termin verlegen"
    set _ballonText(viewDate_Ignore)        "Diesen Termin (nicht mehr) ignorieren"
    set _ballonText(viewDate_SetStatus)     "Stellen Sie hier Ihren Teilnahmestatus fr diesen Termin ein."

    set _ballonText(notiz_New)              "Neue Notiz"
    set _ballonText(notiz_SisplayType)      "Baum- oder Listendarstellung"
    set _ballonText(notiz_FolderViewType)   "Alle Notizen im Ordner,\noder nur Noztizen des\naktuellen Ordners"
    set _ballonText(notiz_Protect)          "Schreibschutz fr dies Notiz.\nm Einschalten werden die\ntzen ndereung abgespeichert."
    set _ballonText(notiz_Undo)             "nderungen zurcknehmen"
    set _ballonText(notiz_Print)            "Notiz drucken"
    set _ballonText(notiz_Mail)             "Notiz per Mail verschicken"
    set _ballonText(notiz_Answer)           "Anschlussnotiz erstellen"


    set _helpText(wmTitle)                  "Minkowsky-Hilfe"
    set _helpText(Contents)                 "Inhaltsverzeichnis"
    set _helpText(intro)                    "Einfhrung"
    set _helpText(cal)                      "Kalender"
    set _helpText(proj)                     "Aufgaben & Projekte"
    set _helpText(addr)                     "Addressbuch"
    set _helpText(perm)                     "Zugriffsrechte"
    set _helpText(faq)                      "FAQ"
    set _helpText(grp)                      "Benutzergruppen"
}
